FastGaussQuadrature.jl
=========
[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaApproximation.github.io/FastGaussQuadrature.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaApproximation.github.io/FastGaussQuadrature.jl/dev)
[![Build Status](https://github.com/JuliaApproximation/FastGaussQuadrature.jl/workflows/CI/badge.svg)](https://github.com/JuliaApproximation/FastGaussQuadrature.jl/actions)
[![codecov](https://codecov.io/gh/JuliaApproximation/FastGaussQuadrature.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaApproximation/FastGaussQuadrature.jl)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)

A Julia package to compute `n`-point Gauss quadrature nodes and weights to 16-digit accuracy and in `O(n)` time.
So far the package includes `gausschebyshev()`, `gausslegendre()`, `gaussjacobi()`, `gaussradau()`, `gausslobatto()`, `gausslaguerre()`, and `gausshermite()`.
This package is heavily influenced by [Chebfun](http://www.chebfun.org).

An introduction to Gauss quadrature can be found [here](http://en.wikipedia.org/wiki/Gaussian_quadrature).
For a quirky account on the history of computing Gauss-Legendre quadrature, see [[6]](http://pi.math.cornell.edu/~ajt/papers/QuadratureEssay.pdf).

## Our Aims

* The fastest Julia code for Gauss quadrature nodes and weights (without tabulation).
* Change the perception that Gauss quadrature rules are expensive to compute.

## Example usage
```julia
julia> @time nodes, weights = gausslegendre( 100000 );
  0.002192 seconds (10 allocations: 2.289 MiB)

# integrates f(x) = x^2 from -1 to 1
julia> @time dot( weights, nodes.^2 )
  0.000184 seconds (7 allocations: 781.422 KiB)
0.6666666666666665
```

@testset "Gauss–Lobatto" begin
    # Check error
    @test_throws DomainError gausslobatto(-1)
    @test_throws DomainError gausslobatto(0)
    @test_throws DomainError gausslobatto(1)

    # Type stability
    @inferred gausslobatto(Float32, 10)
    @inferred gausslobatto(BigFloat, 10)

    n = 2
    x, w = gausslobatto(n)
    @test x[1] ≈ -1.0
    @test x[2] ≈ 1.0
    @test w[1] ≈ 1.0
    @test w[2] ≈ 1.0

    n = 3
    x, w = gausslobatto(n)
    @test x[1] ≈ -1.0
    @test abs(x[2]) < 1.0e-15
    @test x[3] ≈ 1.0
    @test w[1] ≈ 1 / 3
    @test w[2] ≈ 4 / 3
    @test w[3] ≈ 1 / 3

    tol = 1.0e-14
    n = 42
    x, w = gausslobatto(n)
    @test (length(x) == n) && (length(w) == n)
    @test abs(x[37] - 0.922259214258616) < tol
    @test abs(w[37] - 0.029306411216166) < tol
    @test (x[1] == -1 && x[n] == 1)

    @test dot(w, (x .^ 2)) ≈ 2 / 3
    @test dot(w, exp.(x)) ≈ exp(1) - exp(-1)
end

@doc raw"""
    gausslaguerre(n::Integer) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of [Gauss-Laguerre quadrature](https://en.wikipedia.org/wiki/Gauss%E2%80%93Laguerre_quadrature).

```math
\int_{0}^{+\infty} f(x) e^{-x} dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

# Examples
```jldoctest
julia> x, w = gausslaguerre(3);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ 24
true
```
"""
function gausslaguerre(n::Integer)
    return gausslaguerre(n, 0.0)
end


@doc raw"""
    gausslaguerre(n::Integer, α::Real) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of generalized [Gauss-Laguerre quadrature](https://en.wikipedia.org/wiki/Gauss%E2%80%93Laguerre_quadrature).

```math
\int_{0}^{+\infty} f(x) x^\alpha e^{-x} dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

# Examples
```jldoctest
julia> x, w = gausslaguerre(3, 1.0);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ 120
true
```

Optionally, a reduced quadrature rule can be computed. In that case, only those
points and weights are computed for which the weight does not underflow in the
floating point precision type. Supply the optional argument `reduced = true`.

Though the code is generic, heuristical choices on the choice of the algorithm
are based on achieving machine precision accuracy only for `Float64` type. In
case the default choice of algorithm does not achieve the desired accuracy, the
user can manually invoke the following routines:
- `gausslaguerre_GW`: computation based on Golub-Welsch
- `gausslaguerre_rec`: computation based on Newton iterations applied to evaluation
   using the recurrence relation
- `gausslaguerre_asy`: the asymptotic expansions
"""
function gausslaguerre(n::Integer, α::Real; reduced = false)
    if α ≤ -1
        throw(DomainError(α, "The Laguerre parameter α ≤ -1 corresponds to a nonintegrable weight function"))
    end
    if n < 0
        throw(DomainError(n, "gausslaguerre($n,$α) not defined: n must be positive."))
    end

    # Guess the numerical type from the supplied type of α
    # Although the code is generic, the heuristics are derived for Float64 precision
    T = typeof(float(α))
    if n == 0
        T[],T[]
    elseif n == 1
        [1+α], [gamma(1+α)]
    elseif n == 2
        [α + 2-sqrt(α+2),α+2+sqrt(α+2)],
        [((α-sqrt(α+2)+2)*gamma(α+2))/(2*(α+2)*(sqrt(α+2)-1)^2),
         ((α+sqrt(α+2)+2)*gamma(α+2))/(2*(α+2)*(sqrt(α+2)+1)^2)]
    elseif n < 15
        # Use Golub-Welsch for small n
        gausslaguerre_GW(n, α)
    elseif n < 128
        # Use the recurrence relation for moderate n
        gausslaguerre_rec(n, α)
    else
        # Use explicit asymptotic expansions for larger n
        # The restriction to α comes from the restriction on ν in besselroots
        if α < 5
            gausslaguerre_asy(n, α, reduced=reduced, T=-1, recompute=true)
        else
            gausslaguerre_rec(n, α)
        end
    end
end

# Our threshold for deciding on underflow
underflow_threshold(x) = underflow_threshold(typeof(x))
underflow_threshold(::Type{T}) where {T <: AbstractFloat} = 10floatmin(T)


"""
Compute the Gauss-Laguerre rule using explicit asymptotic expansions for the nodes and weights.
Optional parameters are:
- `reduced`: compute a reduced quadrature rule, discarding all points and weights as soon as the weights underflow
- `T`: the order of the expansion. Set `T=-1` to determine the order adaptively depending on the size of the terms in the expansion
- `recompute`: if a crude measure of the error is larger than a tolerance, the point and weight are recomputed using the (slower) recursion+newton approach, yielding more reliable accurate results.
"""
function gausslaguerre_asy(n::Integer, α;
    reduced = false,
    T = max(1, ceil(Int, 50/log(n))),  # Heuristic for number of terms
    recompute = false)

    if α^2/n > 1
        @warn "A large value of α may lead to inaccurate results."
    end

    ELT = typeof(float(α))

    n_alloc = reduced ? 0 : n
    x = zeros(ELT, n_alloc)
    w = zeros(ELT, n_alloc)

    # The expansions are given in powers of 1/(4n+2α+2)
    d = one(ELT)/(4n+2α+2)

    # Heuristical indices for Bessel and Airy regions
    k_bessel = max(ceil(Int, sqrt(n) ), 7)
    k_airy = floor(Int, 0.9*n)

    # The Bessel region
    # First compute the roots of the Bessel function of order α
    jak_vector = approx_besselroots(α, k_bessel)

    bessel_wins = true
    k = 0
    while bessel_wins && k < n
        k += 1
        # We iterate until the estimated error of the bulk expansion is smaller
        # than the one of the Bessel expansion
        jak = (k < k_bessel) ? jak_vector[k] : McMahon(α, k)

        xk, wk, δ_bessel = gausslaguerre_asy_bessel(n, α, jak, d, T)
        xkb, wkb, δ_bulk = gausslaguerre_asy_bulk(n, α, k, d, T)
        if δ_bulk < δ_bessel
            bessel_wins = false
            xk = xkb
            wk = wkb
        end
        if recompute
            δ = min(δ_bessel,δ_bulk)
            if δ > 1e-13
                xk_rec, wk_rec = gl_rec_newton(xk, n, α)
                if abs(xk_rec-xk) < 100δ
                    xk = xk_rec
                    wk = wk_rec
                end
            end
        end
        if reduced
            if abs(wk) < underflow_threshold(ELT)
                return x, w
            else
                push!(x, xk); push!(w, wk)
            end
        else
            x[k] = xk; w[k] = wk
        end
    end

    # The bulk region
    # - First we go from where we left of to our heuristic
    while k < k_airy-1
        k += 1
        xk, wk, δ_bulk = gausslaguerre_asy_bulk(n, α, k, d, T)
        if recompute
            if δ_bulk > 1e-13
                xk_rec, wk_rec = gl_rec_newton(xk, n, α)
                if abs(xk_rec-xk) < 100δ_bulk
                    xk = xk_rec
                    wk = wk_rec
                end
            end
        end
        if reduced
            if abs(wk) < underflow_threshold(ELT)
                return x, w
            else
                push!(x, xk); push!(w, wk)
            end
        else
            x[k] = xk; w[k] = wk
        end
    end

    # - Then we compare to Airy until it wins, and then we switch to just Airy
    bulk_wins = true
    while bulk_wins && k < n
        k += 1
        xk, wk, δ_bulk = gausslaguerre_asy_bulk(n, α, k, d, T)
        xka, wka, δ_airy = gausslaguerre_asy_airy(n, α, k, d, T)
        if δ_airy < δ_bulk
            bulk_wins = false
            xk = xka
            wk = wka
        end
        if recompute
            δ = min(δ_airy,δ_bulk)
            if δ > 1e-13
                xk_rec, wk_rec = gl_rec_newton(xk, n, α)
                if abs(xk_rec-xk) < 100δ
                    xk = xk_rec
                    wk = wk_rec
                end
            end
        end
        if reduced
            if abs(wk) < underflow_threshold(ELT)
                return x, w
            else
                push!(x, xk); push!(w, wk)
            end
        else
            x[k] = xk; w[k] = wk
        end
    end

    # The Airy region
    while k < n
        k += 1
        xk, wk, δ_airy = gausslaguerre_asy_airy(n, α, k, d, T)
        if recompute
            if δ_airy > 1e-13
                xk_rec, wk_rec = gl_rec_newton(xk, n, α)
                if abs(xk_rec-xk) < 100δ_airy
                    xk = xk_rec
                    wk = wk_rec
                end
            end
        end
        if reduced
            if abs(wk) < underflow_threshold(ELT)
                return x, w
            else
                push!(x, xk); push!(w, wk)
            end
        else
            x[k] = xk; w[k] = wk
        end
    end

    # Sanity check
    if ( minimum(x) < 0.0 ) || ( maximum(x) > 4*n + 2*α + 2 ) ||  ( minimum(diff(x)) ≤ 0.0 ) || (minimum(w) < 0.0)
        @warn "Unexpected inconsistency in the computation of nodes and weights"
    end

    return x, w
end

## Expansion coefficients
# These are explicit formulas of the coefficients, up to a simple postprocessing
# that is common to all factors and not included here (see below).
#
# General expressions are given in terms of α, more specific expressions
# follow for the special case α = 0.

## The bulk

# Note: there is always one division by an integer, placed such that it preserves the type of `d`
function gl_bulk(t, d, α)
    α² = α * α
    tinv = inv(1-t)
    _t = (1-t) / t
    _t² = _t * _t
    _t³ = _t² * _t
    d² = d * d
    d⁴ = d² * d²
    d⁶ = d⁴ * d²

    c1 = evalpoly(α², (-4, 12))
    x3 = -evalpoly(tinv, (c1, -4, 5)) * d / 12
    c1, c2 = evalpoly(α², (224, -960, 480)), evalpoly(α², (7, -30, 15))
    x5 = d² * d * _t / 720 * evalpoly(tinv, (c1, -48*c2, -16, -576, 2814, -3815, 1600))
    c1, c2, c3 = evalpoly(α², (-285696, 1354752, -967680, 193536)), evalpoly(α², (-31, 147, -105, 21)), evalpoly(α², (-1346, 6405, -4620, 945))
    c4, c5 = evalpoly(α², (43, -126, 63)), evalpoly(α², (-221, -630, 315))
    x7 = -d⁴ * d / 181440 * _t² * evalpoly(tinv, (c1, -23040*c2, 384*c3, -320*c4, 80*c5, -1727136, 16131880, -48469876, 66424575, -43122800, 10797500))
    c1, c2, c3 = evalpoly(α², (210677760, -1028505600, 812851200, -232243200, 24883200)), evalpoly(α², (127, -620, 490, -140, 15)), evalpoly(α², (1193053, -5826660, 4613070, -1324260, 143325))
    c4, c5, c6 = evalpoly(α², (555239, -2716980, 2163630, -631260, 70875)), evalpoly(α², (-641, 2960, -2155, 450)), evalpoly(α², (-1598, 17685, -13905, 3375))
    c7, c8, c9 = evalpoly(α², (-7823, -9042, 4521)), evalpoly(α², (15948182, -206850, 103425)), evalpoly(α², (64957561, -24000, 12000))
    x9 = d⁶ * d / 10886400 * _t³ * evalpoly(tinv, (c1, -5806080*c2, 768*c3, -768*c4, 16128*c5, -1792*c6, 3360*c7, -192*c8, 672*c9, -212307298152, 518401904799, -714465642135, 566519158800, -241928673000, 43222750000))

    w3 = d² / 6 * (2*t + 3) / (t-1)^3
    c1 = evalpoly(α², (7, -30, 15))
    w5 = d⁴ * _t² / 720  * evalpoly(tinv, (0, 0, 16*c1, 32, 1712, -12408, 27517, -24860, 8000))
    c1, c2, c3 = evalpoly(α², (-31, 147, -105, 21)), evalpoly(α², (-416, 1995, -1470, 315)), evalpoly(α², (43, -126, 63))
    c4, c5 = evalpoly(α², (-89, -378, 189)), evalpoly(α², (53752, -630, 315))
    w7 = -d⁶ * _t³ / 90720 * evalpoly(tinv, (0, 0, 2304*c1, -384*c2, 480*c3, -320*c4, 80*c5, -50986344, 201908326, -386872990, 393326325, -204917300, 43190000))
    return (x3, x5, x7, x9), (w3, w5, w7)
end

function gl_bulk(t, d)
    tinv = inv(1-t)
    _t = (1-t) / t
    _t² = _t * _t
    _t³ = _t² * _t
    d² = d * d
    d⁴ = d² * d²
    d⁶ = d⁴ * d²

    x3 = -d / 12 * evalpoly(tinv, (-4, -4, 5))
    x5 = d² * d * _t / 720 * evalpoly(tinv, (224, -336, -16, -576, 2814, -3815, 1600))
    x7 = -d⁴ * d / 181440 * _t² * evalpoly(tinv, (-285696, 714240, -516864, -13760, -17680, -1727136, 16131880, -48469876, 66424575, -43122800, 10797500))
    x9 = d⁶ * d / 10886400 * _t³ * evalpoly(tinv, (210677760, -737372160, 916264704, -426423552, -10338048, 2863616, -26285280, -3062050944, 43651480992, -212307298152, 518401904799, -714465642135, 566519158800, -241928673000, 43222750000))

    w3 = d² / 6 * (2*t + 3) / (t-1)^3
    w5 = d⁴ / 720 * _t² * evalpoly(tinv, (0, 0, 112, 32, 1712, -12408, 27517, -24860, 8000))
    w7 = -d⁶ * _t³ / 90720 * evalpoly(tinv, (0, 0, -71424, 159744, 20640, 28480, 4300160, -50986344, 201908326, -386872990, 393326325, -204917300, 43190000))
    return (x3, x5, x7, x9), (w3, w5, w7)
end

## The hard edge (Bessel region)
function gl_bessel(jak, d, α)
    jak² = jak * jak
    d² = d * d
    d⁴ = d² * d²
    d⁸ = d⁴ * d⁴
    α² = α * α

    c1 = evalpoly(α², (-2, 2))
    x3 = d² * evalpoly(jak², (c1, 1)) / 3
    w3 = d² * evalpoly(jak², (c1, 2)) / 3
    c1, c2 = evalpoly(α², (94, -140, 46)), evalpoly(α², (-19, 11)) 
    x5 = d⁴ * evalpoly(jak², (c1, 3*c2, 11)) / 45
    w5 = d⁴ * evalpoly(jak², (c1, 6*c2, 33)) / 45
    c1, c2, c3 = evalpoly(α², (-12077, 19887, -9303, 1493)), evalpoly(α², (14051, -10750, 2459)), evalpoly(α², (-181, 73))
    x7 = d⁴ * d² * evalpoly(jak², (4*c1, 2*c2, 36*c3, 657)) / 2835
    w7 = 4 * d⁴ * d² * evalpoly(jak², (c1, c2, 27*c3, 657)) / 2835
    c1, c2, = evalpoly(α², (6029959, -10087180, 5095482, -1146220, 107959)), evalpoly(α², (-2201939, 1678761, -507801, 63299))
    c3, c4 = evalpoly(α², (1456807, -729422, 125671)), evalpoly(α², (-2879, 887))
    x9 = d⁸ * evalpoly(jak², (2*c1, 3*c2, c3, 60*c4, 10644)) / 42525
    w9 = d⁸ * evalpoly(jak², (2*c1, 6*c2, 3*c3, 240*c4, 53220)) / 42525
    return (x3, x5, x7, x9), (w3, w5, w7, w9)
end

# And for α = 0:
function gl_bessel(jak, d)
    jak² = jak * jak
    d² = d * d
    d⁴ = d² * d²
    d⁸ = d⁴ * d⁴

    x3 = d² * evalpoly(jak², (-2, 1)) / 3
    x5 = d⁴ * evalpoly(jak², (94, -57, 11)) / 45
    x7 = d⁴ * d² * evalpoly(jak², (-48308, 28102, -6516, 657)) / 2835
    x9 = d⁸ * evalpoly(jak², (12059918, -6605817, 1456807, -172740, 10644)) / 42525
    x11 = d⁸ * d² * evalpoly(jak², (-11427291076, 6028914206, -1248722004, 138902061, -9908262, 410649)) / 1403325

    w3 = 2 * d² * evalpoly(jak², (-1, 1)) / 3
    w5 = d⁴ * evalpoly(jak², (94, -114, 33)) / 45
    w7 = 4 * d⁴ * d² * evalpoly(jak², (-12077, 14051, -4887, 657)) / 2835
    w9 = d⁸ * evalpoly(jak², (12059918, -13211634, 4370421, -690960, 53220)) / 42525
    w11 = 2 * d⁸ * d² * evalpoly(jak², (-5713645538, 6028914206, -1873083006, 277804122, -24770655, 1231947)) / 1403325
    return (x3, x5, x7, x9, x11), (w3, w5, w7, w9, w11)
end

## The soft edge (Airy region)
function gl_airy(ak, d, α)
    T = eltype(α)
    cbrt_d = cbrt(d)
    cbrt_d2 = cbrt_d * cbrt_d
    ak² = ak * ak
    ak³ = ak² * ak
    ak⁴ = ak² * ak²

    x1 = 1 / d + ak  * cbrt(T(4)) / cbrt_d
    x3 = ak² * cbrt(T(16)) / 5 * cbrt_d + (T(11)/35 - α^2 - T(12)/175*ak³)*d + (T(16)/1575 * ak + T(92)/7875*ak⁴) * cbrt(T(4)) * d * cbrt_d2
    x5 = -(T(15152)/3031875 * ak⁴ * ak + T(1088)/121275 * ak²) * cbrt(T(2)) * d * d * cbrt_d
    return x1, x3, x5
end

# Sum the first Q elements of vals, and return the absolute value of the next
# value in the list (or of the last value in the list)
function sum_explicit(vals, Q)
    T = eltype(vals[1])
    z = zero(T)
    for q = min(Q,length(vals)):-1:1
        z += vals[q]
    end
    if Q < length(vals)
        delta = abs(vals[Q+1])
    else
        delta = abs(vals[end])
    end
    z, delta
end

function sum_adaptive(vals)
    z = vals[1]
    i = 1
    while (i < length(vals)) && (abs(vals[i+1]) < abs(vals[i]))
        i += 1
        z += vals[i]
    end
    delta = abs(vals[min(i+1,length(vals))])
    z, delta
end

function gl_bulk_solve_t(n, k, d)
    T = typeof(d)
    pt = (4n-4k+3)*d
    t = T(π)^2/16*(pt-1)^2
    diff = 100
    iter = 0
    maxiter = 20
    while (abs(diff) > 100eps(T)) && (iter < maxiter)
        iter += 1
        diff = (pt*π +2*sqrt(t-t^2) -acos(2*t-1) )*sqrt(t/(1-t))/2
        t -= diff
    end
    if iter == maxiter
        @warn "Maximal number of iterations reached in the computation of t for the bulk"
    end
    t
end

function gausslaguerre_asy_bulk(n, α, k, d, T)
    if α == 0
        return gausslaguerre_asy0_bulk(n, k, d, T)
    end

    t = gl_bulk_solve_t(n, k, d)
    xs, ws = gl_bulk(t, d, α)

    xk, xdelta = (T > 0) ? sum_explicit(xs, (T-1)>>1) : sum_adaptive(xs)
    wk, wdelta = (T > 0) ? sum_explicit(ws, (T-1)>>1) : sum_adaptive(ws)

    xk += t/d

    wfactor = xk^α * exp(-xk) * 2π * sqrt(t/(1-t))
    wk = wfactor * (1+wk)
    wdelta *= wfactor

    xk, wk, max(xdelta,wdelta)
end


function gausslaguerre_asy0_bulk(n, k, d, T)
    t = gl_bulk_solve_t(n, k, d)
    xs, ws = gl_bulk(t, d)


    xk, xdelta = (T > 0) ? sum_explicit(xs, (T-1)>>1) : sum_adaptive(xs)
    wk, wdelta = (T > 0) ? sum_explicit(ws, (T-1)>>1) : sum_adaptive(ws)

    xk += t/d

    wfactor = exp(-xk) * 2π * sqrt(t/(1-t))
    wk = wfactor * (1+wk)
    wdelta *= wfactor

    xk, wk, max(xdelta,wdelta)
end


function gausslaguerre_asy_bessel(n, α, jak, d, T)
    if α == 0
        return gausslaguerre_asy0_bessel(n, jak, d, T)
    end

    xs, ws = gl_bessel(jak, d, α)

    xk, xdelta = (T > 0) ? sum_explicit(xs, (T-1)>>1) : sum_adaptive(xs)
    wk, wdelta = (T > 0) ? sum_explicit(ws, (T-1)>>1) : sum_adaptive(ws)

    xfactor = jak^2 * d
    xk = xfactor * (1 + xk)
    xdelta *= xfactor

    # Invoking the besselj function below is the cause of memory
    # allocation of this routine
    wfactor = 4d * xk^α * exp(-xk) / besselj(α-1, jak)^2
    wk = wfactor * (1 + wk)
    wdelta *= wfactor

    return xk, wk, max(xdelta,wdelta)
end

function gausslaguerre_asy0_bessel(n, jak, d, T)
    xs, ws = gl_bessel(jak, d)
  
    xk, xdelta = (T > 0) ? sum_explicit(xs, (T-1)>>1) : sum_adaptive(xs)
    wk, wdelta = (T > 0) ? sum_explicit(ws, (T-1)>>1) : sum_adaptive(ws)

    xfactor = jak^2 * d
    xk = xfactor * (1 + xk)
    xdelta *= xfactor

    wfactor = 4d * exp(-xk) / besselj(-1, jak)^2
    wk = wfactor * (1 + wk)
    wdelta *= wfactor

    return xk, wk, max(xdelta,wdelta)
end

function compute_airy_root(n, k)
    index = n-k+1
    if index ≤ 11
        ak = AIRY_ROOTS[index]
    else
        t = 3 * π/2 * (index-0.25)
        ak = -t^(2/3) * evalpoly(inv(t*t), (6967296, 725760, -967680, 6478500, -10856875)) / 6967296
    end
    ak
end

function gausslaguerre_asy_airy(n, α, k, d, T)
    ak = compute_airy_root(n, k)
    xs = gl_airy(ak, d, α)

    xk, xdelta = (T > 0) ? sum_explicit(xs, (T+1)>>1) : sum_adaptive(xs)

    wk = 4^(1/3)*xk^(α+1/3)*exp(-xk)/(airyaiprime(ak))^2
    wdelta = abs(wk)

    return xk, wk, max(xdelta,wdelta)
end

"""
Calculate Gauss-Laguerre nodes and weights from the eigenvalue decomposition of
the Jacobi matrix.
"""
function gausslaguerre_GW(n, α)
    _α = 2*(1:n) .+ (α-1)  # 3-term recurrence coeffs a and b
    β = sqrt.( (1:n-1).*(α .+ (1:n-1)) )
    T = SymTridiagonal(promote(collect(_α), β)...)
    x, V = eigen(T)  # eigenvalue decomposition
    w = gamma(α+1)*V[1,:].^2  # Quadrature weights
    return x, vec(w)
end


########################## Routines for the forward recurrence ##########################

function gl_rec_newton(x0, n, α; maxiter = 20, computeweight = true)
    T = eltype(x0)
    step = x0
    iter = 0
    xk = x0

    xk_prev = xk
    pn_prev = floatmax(T)
    pn_deriv = zero(T)
    while (abs(step) > 40eps(T)*xk) && (iter < maxiter)
        iter += 1
        pn, pn_deriv = evalLaguerreRec(n, α, xk)
        if abs(pn) ≥ abs(pn_prev)*(1-50eps(T))
            # The function values do not decrease enough any more due to roundoff errors.
            xk = xk_prev # Set to the previous value and quit.
            break
        end
        step = pn / pn_deriv
        xk_prev = xk
        xk -= step
        pn_prev = pn
    end
    if ( xk < 0 ) || ( xk > 4n + 2α + 2 ) || ( iter == maxiter )
        @warn "Newton method may not have converged in gausslaguerre_rec($n,$α)."
    end
    wk = oftype(xk, 0)
    if computeweight
        pn_min1, ~ = evalLaguerreRec(n-1, α, xk)
        wk = (n^2 +α*n)^(-1/2)/pn_min1/pn_deriv
    end

    return xk, wk
end

"Compute Gauss-Laguerre rule based on the recurrence relation, using Newton iterations on an initial guess."
function gausslaguerre_rec(n, α; reduced = false)
    T = typeof(float(α))

    n_alloc = reduced ? 0 : n
    w = zeros(T, n_alloc)
    x = zeros(T, n_alloc)

    # We compute up to 7 starting values for the Newton iterations
    n_pre = min(n, 7)

    ν = 4n + 2α + 2
    x_pre = T.(approx_besselroots(α, n_pre)).^2 / ν # this is a lower bound by [DLMF 18.16.10]

    noUnderflow = true  # this flag turns false once the weights start to underflow
    for k in 1:n
        # Use sextic extrapolation for a new initial guess
        xk = (k ≤ n_pre) ? x_pre[k] : 7*x[k-1] -21*x[k-2] +35*x[k-3] -35*x[k-4] +21*x[k-5] -7*x[k-6] +x[k-7]

        xk, wk = gl_rec_newton(xk, n, α, maxiter = 20, computeweight = noUnderflow)
        if noUnderflow && abs(wk) < underflow_threshold(T)
            noUnderflow = false
        end

        if reduced
            if !noUnderflow
                return x, w
            else
                push!(x, xk); push!(w, wk)
            end
        else
            x[k] = xk
            w[k] = wk
        end
    end

    return x, w
end


"""
Evaluate the orthonormal associated Laguerre polynomial with positive leading coefficient,
as well as its derivative, in the point x using the recurrence relation.
"""
function evalLaguerreRec(n, α, x)
    T = typeof(α)
    pnprev = zero(T)
    pn = 1/sqrt(gamma(α+1))
    pndprev = zero(T)
    pnd = zero(T)
    for k in 1:n
        pnold = pn
        pn = (x -2*k -α+1)/sqrt(k*(α+k))*pnold-sqrt((k-1+α)*(k-1)/k/(k+α))*pnprev
        pnprev = pnold
        pndold = pnd
        pnd = (pnold+(x-2*k-α+1)*pndold)/sqrt(k*(α+k)) -sqrt((k-1+α)*(k-1)/k/(α+k))*pndprev
        pndprev = pndold
    end

    return pn, pnd
end

@doc raw"""
    gaussjacobi(n::Integer, α::Real, β::Real) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of [Gauss-Jacobi quadrature](https://en.wikipedia.org/wiki/Gauss%E2%80%93Jacobi_quadrature)
for exponents `α` and `β`.

```math
\int_{-1}^{1} f(x) (1-x)^\alpha(1+x)^\beta dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

# Examples
```jldoctest
julia> x, w = gaussjacobi(3, 1/3, -1/3);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ 268π/729(√3)
true
```
"""
function gaussjacobi(n::Integer, α::Real, β::Real)
    T = typeof(α)
    #GAUSS-JACOBI QUADRATURE NODES AND WEIGHTS
    if n < 0
        throw(DomainError(n, "gaussjacobi($n,$α,$β) not defined: n must be non-negative."))
    elseif iszero(α) && iszero(β)
        return gausslegendre(T, n)
    elseif abs(α) == abs(β) == 0.5
        if α == -0.5 && β == -0.5
            return gausschebyshevt(T, n)
        elseif α == 0.5 && β == 0.5
            return gausschebyshevu(T, n)
        elseif α == -0.5 && β == 0.5
            return gausschebyshevv(T, n)
        elseif α == 0.5 && β == -0.5
            return gausschebyshevw(T, n)
        end
    elseif n == 0
        return T[], T[]
    elseif n == 1
        return [(β - α) / (α + β + 2)], [2^(α + β + 1) * beta(α + 1, β + 1)]
    elseif min(α, β) ≤ -1.0
        return throw(DomainError((α, β), "The Jacobi parameters correspond to a nonintegrable weight function"))
    elseif n ≤ 100 && max(α, β) < 5.0
        return jacobi_rec(n, α, β)
    elseif n > 100 && max(α, β) < 5.0
        return jacobi_asy(n, α, β)
    elseif n ≤ 4000 && max(α, β) ≥ 5.0
        return jacobi_gw(n, α, β)
    else
        error("gaussjacobi($n,$α,$β) is not implemented: n must be ≤ 4000 for max(α,β) ≥ 5.")
    end
end

# Convenience function: convert any kind of numbers a and b to a joint floating point type
jacobi_rec(n::Integer, α::Real, β::Real) = jacobi_rec(n, promote(float(α), float(β))...)
jacobi_asy(n::Integer, α::Real, β::Real) = jacobi_asy(n, promote(float(α), float(β))...)

function jacobi_rec(n::Integer, α::T, β::T) where {T <: AbstractFloat}
    #Compute nodes and weights using recurrrence relation.
    x11, x12 = HalfRec(n, α, β, 1)
    x21, x22 = HalfRec(n, β, α, 0)

    x = Array{T}(undef, n)
    w = Array{T}(undef, n)
    m1 = length(x11)
    m2 = length(x21)
    sum_w = zero(T)
    @inbounds for i in 1:m2
        idx = m2 + 1 - i
        xi = -x21[i]
        der = x22[i]
        wi = 1 / ((1 - xi^2) * der^2)
        w[idx] = wi
        x[idx] = xi
        sum_w += wi
    end
    @inbounds for i in 1:m1
        idx = m2 + i
        xi = x11[i]
        der = x12[i]
        wi = 1 / ((1 - xi^2) * der^2)
        w[idx] = wi
        x[idx] = xi
        sum_w += wi
    end
    c = (2^(α + β + 1) * gamma(2 + α) * gamma(2 + β) / (gamma(2 + α + β) * (α + 1) * (β + 1)))
    rmul!(w, c / sum_w)
    return x, w
end

function HalfRec(n::Integer, α::T, β::T, flag) where {T <: AbstractFloat}
    # HALFREC  Jacobi polynomial recurrence relation.
    # Asymptotic formula - only valid for positive x.
    r = (flag == 1) ? (ceil(n / 2):-1:1) : (floor(n / 2):-1:1)
    m = length(r)
    c1 = 1 / (2 * n + α + β + 1)
    a1 = one(T) / 4 - α^2
    b1 = one(T) / 4 - β^2
    c1² = c1^2
    x = Array{T}(undef, m)
    @inbounds for i in 1:m
        C = muladd(2 * one(T), r[i], α - one(T) / 2) * (T(π) * c1)
        C_2 = C / 2
        x[i] = cos(muladd(c1², muladd(-b1, tan(C_2), a1 * cot(C_2)), C))
    end

    P1 = Array{T}(undef, m)
    P2 = Array{T}(undef, m)
    # Loop until convergence:
    for _ in 1:10
        innerjacobi_rec!(n, x, α, β, P1, P2)
        dx2 = 0.0
        @inbounds for i in 1:m
            dx = P1[i] / P2[i]
            _dx2 = abs2(dx)
            dx2 = ifelse(_dx2 > dx2, _dx2, dx2)
            x[i] = x[i] - dx
        end
        dx2 > eps(T) / 1.0e6 || break
    end
    # Once more for derivatives:
    innerjacobi_rec!(n, x, α, β, P1, P2)
    return x, P2
end

function innerjacobi_rec!(n, x, α::T, β::T, P, PP) where {T <: AbstractFloat}
    # EVALUATE JACOBI POLYNOMIALS AND ITS DERIVATIVE USING THREE-TERM RECURRENCE.
    N = length(x)
    @inbounds for j in 1:N
        xj = x[j]

        Pj = (α - β + (α + β + 2) * xj) / 2
        Pm1 = one(T)
        PPj = (α + β + 2) / 2
        PPm1 = zero(T)
        for k in 1:(n - 1)
            k0 = muladd(2 * one(T), k, α + β)
            k1 = k0 + 1
            k2 = k0 + 2
            A = 2 * (k + 1) * (k + (α + β + 1)) * k0
            B = k1 * (α^2 - β^2)
            C = k0 * k1 * k2
            D = 2 * (k + α) * (k + β) * k2
            c1 = muladd(C, xj, B)
            Pm1, Pj = Pj, muladd(-D, Pm1, c1 * Pj) / A
            PPm1, PPj = PPj, muladd(c1, PPj, muladd(-D, PPm1, C * Pm1)) / A
        end
        P[j] = Pj
        PP[j] = PPj
    end
    return nothing
end

function weightsConstant(n, α, β)
    # Compute the constant for weights:
    M = min(20, n - 1)
    C = 1.0
    p = -α * β / n
    for m in 1:M
        C += p
        p *= -(m + α) * (m + β) / (m + 1) / (n - m)
        abs(p / C) < eps(Float64) / 100 && break
    end
    return 2^(α + β + 1) * C
end

function jacobi_asy(n::Integer, α::Float64, β::Float64)
    # ASY  Compute nodes and weights using asymptotic formulae.

    # Determine switch between interior and boundary regions:
    nbdy = 10
    bdyidx1 = (n - (nbdy - 1)):n
    bdyidx2 = nbdy:-1:1

    # Interior formula:
    x, w = asy1(n, α, β, nbdy)

    # Boundary formula (right):
    xbdy = asy2(n, α, β, nbdy)
    x[bdyidx1], w[bdyidx1] = xbdy

    # Boundary formula (left):
    if α ≠ β
        xbdy = asy2(n, β, α, nbdy)
    end
    x[bdyidx2] = -xbdy[1]
    w[bdyidx2] = xbdy[2]

    rmul!(w, weightsConstant(n, α, β))
    return x, w
end

function asy1(n::Integer, α::Float64, β::Float64, nbdy::Integer)
    # Algorithm for computing nodes and weights in the interior.

    # Approximate roots via asymptotic formula: (Gatteschi and Pittaluga, 1985)
    K = π * (2(n:-1:1) .+ α .- 0.5) / (2n + α + β + 1)
    tt = K .+ (1 / (2n + α + β + 1)^2) .* ((0.25 - α^2) .* cot.(K / 2) .- (0.25 - β^2) .* tan.(K / 2))

    # First half (x > 0):
    t = tt[tt .≤ π / 2]
    mint = t[end - nbdy + 1]
    idx = 1:max(findfirst(t .< mint) - 1, 1)

    # Newton iteration
    for _ in 1:10
        vals, ders = feval_asy1(n, α, β, t, idx)  # Evaluate
        dt = vals ./ ders
        t += dt  # Next iterate
        if norm(dt[idx], Inf) < sqrt(eps(Float64)) / 100
            break
        end
    end
    vals, ders = feval_asy1(n, α, β, t, idx)  # Once more for luck
    t += vals ./ ders

    # Store
    x_right = cos.(t)
    w_right = 1 ./ ders .^ 2

    # Second half (x < 0):
    α, β = β, α
    t = π .- tt[1:(n - length(x_right))]
    mint = t[nbdy]
    idx = max(findfirst(t .> mint), 1):length(t)

    # Newton iteration
    for _ in 1:10
        vals, ders = feval_asy1(n, α, β, t, idx)  # Evaluate.
        dt = vals ./ ders  # Newton update.
        t += dt
        if norm(dt[idx], Inf) < sqrt(eps(Float64)) / 100
            break
        end
    end
    vals, ders = feval_asy1(n, α, β, t, idx)  # Once more for luck.
    t += vals ./ ders  # Newton update.

    # Store
    x_left = cos.(t)
    w_left = 1 ./ ders .^ 2

    return vcat(-x_left, x_right), vcat(w_left, w_right)
end

"""
Evaluate the interior asymptotic formula at x = cos(t).
Assumption:
* `length(t) == n ÷ 2`
"""
function feval_asy1(n::Integer, α::Float64, β::Float64, t::AbstractVector, idx)
    # Number of terms in the expansion:
    M = 20

    # Number of elements in t:
    N = length(t)

    # The sine and cosine terms:
    A = repeat((2n + α + β) .+ (1:M), 1, N) .* repeat(t', M) / 2 .- (α + 1 / 2) * π / 2  # M × N matrix
    cosA = cos.(A)
    sinA = sin.(A)

    sinT = repeat(sin.(t)', M)
    cosT = repeat(cos.(t)', M)
    cosA2 = cosA .* cosT .+ sinA .* sinT
    sinA2 = sinA .* cosT .- cosA .* sinT

    sinT = hcat(ones(N), cumprod(repeat((csc.(t / 2) / 2), 1, M - 1), dims = 2))  # M × N matrix
    secT = sec.(t / 2) / 2

    _vec = [(α + j - 1 / 2) * (-α + j - 1 / 2) / (2n + α + β + j + 1) / j for j in 1:(M - 1)]
    P1 = [1;cumprod(_vec)]
    P1[3:4:end] = -P1[3:4:end]
    P1[4:4:end] = -P1[4:4:end]
    P2 = Matrix(1.0I, M, M)
    for l in 1:M
        _vec = [(β + j - 1 / 2) * (-β + j - 1 / 2) / (2n + α + β + j + l) / j for j in 1:(M - l - 2)]
        P2[l, (l + 1):(M - 2)] = cumprod(_vec)
    end
    PHI = repeat(P1, 1, M) .* P2

    _vec = [(α + j - 1 / 2) * (-α + j - 1 / 2) / (2n + α + β + j - 1) / j for j in 1:(M - 1)]
    P1 = [1;cumprod(_vec)]
    P1[3:4:end] = -P1[3:4:end]
    P1[4:4:end] = -P1[4:4:end]
    P2 = Matrix(1.0I, M, M)
    for l in 1:M
        _vec = [(β + j - 1 / 2) * (-β + j - 1 / 2) / (2n + α + β + j + l - 2) / j for j in 1:(M - l - 2)]
        P2[l, (l + 1):(M - 2)] = cumprod(_vec)
    end
    PHI2 = repeat(P1, 1, M) .* P2

    S = zeros(N)
    S2 = zeros(N)
    for m in 1:M
        l = 1:2:m
        phi = PHI[l, m]
        dS1 = (sinT[:, l] * phi) .* cosA[m, :]
        phi2 = PHI2[l, m]
        dS12 = (sinT[:, l] * phi2) .* cosA2[m, :]
        l = 2:2:m
        phi = PHI[l, m]
        dS2 = (sinT[:, l] * phi) .* sinA[m, :]
        phi2 = PHI2[l, m]
        dS22 = (sinT[:, l] * phi2) .* sinA2[m, :]
        if m - 1 > 10 && norm(dS1[idx] + dS2[idx], Inf) < eps(Float64) / 100
            break
        end
        S .+= dS1
        S .+= dS2
        S2 .+= dS12
        S2 .+= dS22
        sinT[:, 1:m] .*= secT
    end

    # Constant out the front:
    dsa = α^2 / 2n
    dsb = β^2 / 2n
    dsab = (α + β)^2 / 4n
    ds = dsa + dsb - dsab
    s = ds
    i = 1
    dsold = ds # to fix α = -β bug.
    while abs(ds / s) + dsold > eps(Float64) / 10
        dsold = abs(ds / s)
        i += 1
        tmp = -(i - 1) / (i + 1) / n
        dsa = tmp * dsa * α
        dsb = tmp * dsb * β
        dsab = tmp * dsab * (α + β) / 2
        ds = dsa + dsb - dsab
        s = s + ds
    end
    p2 = exp(s) * sqrt(2π * (n + α) * (n + β) / (2n + α + β)) / (2n + α + β + 1)
    # g is a vector of coefficients in
    # ``\Gamma(z) = \frac{z^{z-1/2}}{\exp(z)}\sqrt{2\pi} \left(\sum_{i} B_i z^{-i}\right)``, where B_{i-1} = g[i].
    # https://math.stackexchange.com/questions/1714423/what-is-the-pattern-of-the-stirling-series
    g = [
        1, 1 / 12, 1 / 288, -139 / 51840, -571 / 2488320, 163879 / 209018880,
        5246819 / 75246796800, -534703531 / 902961561600,
        -4483131259 / 86684309913600, 432261921612371 / 514904800886784000,
    ]
    f(z) = dot(g, [1;cumprod(ones(9) ./ z)])

    # Float constant C, C2
    C = 2 * p2 * (f(n + α) * f(n + β) / f(2n + α + β)) / π
    C2 = C * (α + β + 2n) * (α + β + 1 + 2n) / (4 * (α + n) * (β + n))

    vals = C * S

    # Use relation for derivative:
    ders = (n * ((α - β) .- (2n + α + β) * cos.(t)) .* vals .+ (2 * (n + α) * (n + β) * C2) .* S2) ./ (2n + α + β) ./ sin.(t)
    denom = 1 ./ (sin.(abs.(t) / 2) .^ (α + 0.5) .* cos.(t / 2) .^ (β + 0.5))
    vals .*= denom
    ders .*= denom

    return vals, ders
end

function asy2(n::Integer, α::Float64, β::Float64, npts::Integer)
    # Algorithm for computing nodes and weights near the boundary.

    # Use Newton iterations to find the first few Bessel roots:
    jk = approx_besselroots(α, npts)

    # Approximate roots via asymptotic formula: (see Olver 1974, NIST, 18.16.8)
    phik = jk / (n + 0.5 * (α + β + 1))
    t = phik .+ ((α^2 - 0.25) .* (1 .- phik .* cot.(phik)) ./ (2 * phik) .- 0.25 .* (α^2 - β^2) .* tan.(0.5 .* phik)) ./ (n + 0.5 * (α + β + 1))^2

    # Compute higher terms:
    higherterms = asy2_higherterms(α, β, t)

    # Newton iteration:
    for _ in 1:10
        vals, ders = feval_asy2(n, α, β, t, higherterms)  # Evaluate via asymptotic formula.
        dt = vals ./ ders  # Newton update.
        t += dt  # Next iterate.
        if norm(dt, Inf) < sqrt(eps(Float64)) / 200
            break
        end
    end
    vals, ders = feval_asy2(n, α, β, t, higherterms)  # Evaluate via asymptotic formula.
    dt = vals ./ ders
    t += dt

    # flip:
    t = reverse(t)
    ders = reverse(ders)

    # Revert to x-space:
    x = cos.(t)
    w = 1 ./ ders .^ 2

    return x, w
end

"""
Evaluate the boundary asymptotic formula at x = cos(t).
Assumption:
* `length(t) == n ÷ 2`
"""
function feval_asy2(n::Integer, α::Float64, β::Float64, t::AbstractVector, higherterms::HT) where {HT <: Tuple{<:Function, <:Function, <:Function, <:Function}}
    rho = n + 0.5 * (α + β + 1)
    rho2 = n + 0.5 * (α + β - 1)
    A = (0.25 - α^2)
    B = (0.25 - β^2)

    # Evaluate the Bessel functions:
    Ja = besselj.(α, rho * t)
    Jb = besselj.(α + 1, rho * t)
    Jbb = besselj.(α + 1, rho2 * t)
    Jab = bessel_taylor(-t, rho * t, α)

    # Evaluate functions for recursive definition of coefficients:
    gt = A * (cot.(t / 2) .- (2 ./ t)) .- B * tan.(t / 2)
    gtdx = A * (2 ./ t .^ 2 .- 0.5 * csc.(t / 2) .^ 2) .- 0.5 * B * sec.(t / 2) .^ 2
    tB0 = 0.25 * gt
    A10 = α * (A + 3 * B) / 24
    A1 = gtdx / 8 .- (1 + 2 * α) / 8 * gt ./ t .- gt .^ 2 / 32 .- A10
    # Higher terms:
    tB1, A2, tB2, A3 = higherterms
    tB1t = tB1(t)
    A2t = A2(t)

    # VALS:
    vals = Ja + Jb .* tB0 / rho + Ja .* A1 / rho^2 + Jb .* tB1t / rho^3 + Ja .* A2t / rho^4
    # DERS:
    vals2 = Jab + Jbb .* tB0 / rho2 + Jab .* A1 / rho2^2 + Jbb .* tB1t / rho2^3 + Jab .* A2t / rho2^4

    # Higher terms (not needed for n > 1000).
    tB2t = tB2(t)
    A3t = A3(t)
    vals .+= Jb .* tB2t / rho^5 + Ja .* A3t / rho^6
    vals2 .+= Jbb .* tB2t / rho2^5 + Jab .* A3t / rho2^6

    # Constant out the front (Computed accurately!)
    ds = 0.5 * (α^2) / n
    s = ds
    jj = 1
    while abs(ds / s) > eps(Float64) / 10
        jj = jj + 1
        ds = -(jj - 1) / (jj + 1) / n * (ds * α)
        s = s + ds
    end
    p2 = exp(s) * sqrt((n + α) / n) * (n / rho)^α
    g = [
        1, 1 / 12, 1 / 288, -139 / 51840, -571 / 2488320, 163879 / 209018880,
        5246819 / 75246796800, -534703531 / 902961561600,
        -4483131259 / 86684309913600, 432261921612371 / 514904800886784000,
    ]
    f(z) = dot(g, [1;cumprod(ones(9) ./ z)])
    C = p2 * (f(n + α) / f(n)) / sqrt(2)

    # Scaling:
    valstmp = C * vals
    denom = sin.(t / 2) .^ (α + 0.5) .* cos.(t / 2) .^ (β + 0.5)
    vals = sqrt.(t) .* valstmp ./ denom

    # Relation for derivative:
    C2 = C * n / (n + α) * (rho / rho2)^α
    ders = (n * (α - β .- (2n + α + β) * cos.(t)) .* valstmp .+ 2 * (n + α) * (n + β) * C2 * vals2) / (2n + α + β)
    ders .*= sqrt.(t) ./ (denom .* sin.(t))

    return vals, ders
end

function asy2_higherterms(α::Float64, β::Float64, theta::AbstractVector)
    # Higher-order terms for boundary asymptotic series.
    # Compute the higher order terms in asy2 boundary formula. See [2].

    # These constants are more useful than α and β:
    A = (0.25 - α^2)
    B = (0.25 - β^2)

    # For now, just work on half of the domain:
    c = max(maximum(theta), 0.5)

    # Use 10 Chebyshev modes in order to use precomputed integration and
    # differentiation matrices
    N = 10

    # Scaled 2nd-kind Chebyshev points and barycentric weights:
    t = 0.5 * c * (sin.(pi * (-(N - 1):2:(N - 1)) / (2 * (N - 1))) .+ 1)
    v = [0.5; ones(N - 1)]
    v[2:2:end] .= -1
    v[end] *= 0.5

    # The g's:
    g = A * (cot.(t / 2) - 2 ./ t) - B * tan.(t / 2)
    gp = A * (2 ./ t .^ 2 - 0.5 * csc.(t / 2) .^ 2) - 0.5 * (0.25 - β^2) * sec.(t / 2) .^ 2
    gpp = A * (-4 ./ t .^ 3 + 0.25 * sin.(t) .* csc.(t / 2) .^ 4) - 4 * B * sin.(t / 2) .^ 4 .* csc.(t) .^ 3
    g[1] = 0
    gp[1] = -A / 6 - 0.5 * B
    gpp[1] = 0

    # B0:
    B0 = 0.25 * g ./ t
    B0p = 0.25 * (gp ./ t - g ./ t .^ 2)
    B0[1] = 0.25 * (-A / 6 - 0.5 * B)
    B0p[1] = 0

    # A1:
    A10 = α * (A + 3 * B) / 24
    A1 = 0.125 * gp .- (1 + 2 * α) / 2 * B0 .- g .^ 2 / 32 .- A10
    A1p = 0.125 * gpp .- (1 + 2 * α) / 2 * B0p .- gp .* g / 16
    A1p_t = A1p ./ t
    A1p_t[1] = -A / 720 - A^2 / 576 - A * B / 96 - B^2 / 64 - B / 48 + α * (A / 720 + B / 48)

    # Make f accurately: (Taylor series approx for small t)
    fcos = B ./ (2 * cos.(t / 2)) .^ 2
    f = -A * (
        1 / 12 .+ t .^ 2 / 240 + t .^ 4 / 6048 + t .^ 6 / 172800 + t .^ 8 / 5322240 +
            691 * t .^ 10 / 118879488000 + t .^ 12 / 5748019200 +
            3617 * t .^ 14 / 711374856192000 + 43867 * t .^ 16 / 300534953951232000
    )
    idx = t .> 0.5
    f[idx] = A .* (1 ./ t[idx] .^ 2 - 1 ./ (2 * sin.(t[idx] / 2)) .^ 2)
    f .-= fcos

    # Integrals for B1: (Note that N isn't large, so we don't need to be fancy).
    C = (0.5 * c) * CUMSUMMAT_10
    D = (2 / c) * DIFFMAT_10
    I = (C * A1p_t)
    J = (C * (f .* A1))

    # B1:
    tB1 = -0.5 * A1p - (0.5 + α) * I + 0.5 * J
    tB1[1] = 0
    B1 = tB1 ./ t
    B1[1] = A / 720 + A^2 / 576 + A * B / 96 + B^2 / 64 + B / 48 +
        α * (A^2 / 576 + B^2 / 64 + A * B / 96) - α^2 * (A / 720 + B / 48)

    # A2:
    K = C * (f .* tB1)
    A2 = 0.5 * (D * tB1) - (0.5 + α) * B1 - 0.5 * K
    A2 .-= A2[1]

    # A2p:
    A2p = D * A2
    A2p .-= A2p[1]
    A2p_t = A2p ./ t
    # Extrapolate point at t = 0:
    w = pi / 2 .- t[2:end]
    w[2:2:end] = -w[2:2:end]
    w[end] = 0.5 * w[end]
    A2p_t[1] = sum(w .* A2p_t[2:end]) / sum(w)

    # B2:
    tB2 = -0.5 * A2p - (0.5 + α) * (C * A2p_t) + 0.5 * C * (f .* A2)
    B2 = tB2 ./ t
    # Extrapolate point at t = 0:
    B2[1] = sum(w .* B2[2:end]) / sum(w)

    # A3:
    K = C * (f .* tB2)
    A3 = 0.5 * (D * tB2) - (0.5 + α) * B2 - 0.5 * K
    A3 .-= A3[1]

    tB1f(theta) = bary(theta, tB1, t, v)
    A2f(theta) = bary(theta, A2, t, v)
    tB2f(theta) = bary(theta, tB2, t, v)
    A3f(theta) = bary(theta, A3, t, v)

    return tB1f, A2f, tB2f, A3f
end

function jacobi_jacobimatrix(n, α, β)
    s = α + β
    ii = 2:(n - 1)
    si = 2 * ii .+ s
    aa = [
        (β - α) / (2 + s);
        (β^2 - α^2) ./ ((si .- 2) .* si);
        (β^2 - α^2) ./ ((2n - 2 + s) .* (2n + s))
    ]
    bb = [
        2 * sqrt((1 + α) * (1 + β) / (s + 3)) / (s + 2) ;
        2 .* sqrt.(ii .* (ii .+ α) .* (ii .+ β) .* (ii .+ s) ./ (si .^ 2 .- 1)) ./ si
    ]
    return SymTridiagonal(aa, bb)
end

function jacobimoment(α, β)
    s = α + β
    T = float(typeof(s))
    # Same as 2^(α+β+1) * beta(α+1,β+1)
    return exp((s + 1) * log(convert(T, 2)) + loggamma(α + 1) + loggamma(β + 1) - loggamma(2 + s))
end

function jacobi_gw(n::Integer, α, β)
    # Golub-Welsh for Gauss--Jacobi quadrature. This is used when max(α,β)>5.
    x, V = eigen(jacobi_jacobimatrix(n, α, β))  # Eigenvalue decomposition.
    # Quadrature weights:
    w = V[1, :] .^ 2 .* jacobimoment(α, β)
    return x, w
end

function bary(x::AbstractVector, fvals::AbstractVector, xk::AbstractVector, vk::AbstractVector)
    # simple barycentric interpolation routine adapted from chebfun/bary.m

    # Initialise return value:
    fx = zeros(length(x))

    # Loop:
    for j in eachindex(x)
        xx = vk ./ (x[j] .- xk)
        fx[j] = dot(xx, fvals) / sum(xx)
    end

    # Try to clean up NaNs:
    for k in findall(isnan.(fx))
        index = findfirst(x[k] .== xk) # Find the corresponding node
        if !isempty(index)
            fx[k] = fvals[index]       # Set entries to the correct value
        end
    end

    return fx
end

function bessel_taylor(t::AbstractVector, z::AbstractVector, α::Float64)
    # Accurate evaluation of Bessel function J_A for asy2. (See [2].)
    # evaluates J_A(Z+T) by a Taylor series expansion about Z.

    npts = length(t)
    kmax = min(ceil(Int64, abs(log(eps(Float64)) / log(norm(t, Inf)))), 30)
    H = t' .^ (0:kmax)
    # Compute coeffs in Taylor expansions about z (See NIST 10.6.7)
    nu = ones(Int64, length(z)) * (-kmax:kmax)'
    JK = z * ones(2kmax + 1)'
    Bjk = besselj.(α .+ nu, JK)
    nck = nck_mat(floor(Int64, 1.25 * kmax)) # nchoosek
    AA = [Bjk[:, kmax + 1] zeros(npts, kmax)]
    fact = 1
    for k in 1:kmax
        sgn = 1
        for l in 0:k
            AA[:, k + 1] = AA[:, k + 1] + sgn * nck[k, l + 1] * Bjk[:, kmax + 2 * l - k + 1]
            sgn = -sgn
        end
        fact = k * fact
        AA[:, k + 1] ./= 2^k * fact
    end
    # Evaluate Taylor series:
    Ja = zeros(npts)
    for k in 1:npts
        Ja[k] = dot(AA[k, :], H[:, k])
    end

    return Ja
end

function nck_mat(n::Integer)
    # almost triangular matrix storing n choose k
    M = zeros(Int64, n - 1, n)
    M[:, 1] .= 1
    M[1, 2] = 1
    for i in 2:(n - 1)
        for j in 2:(i + 1)
            M[i, j] = M[i - 1, j - 1] + M[i - 1, j]
        end
    end
    return M
end

@doc raw"""
    gaussradau(n::Integer) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of [Gauss-Radau quadrature](https://mathworld.wolfram.com/RadauQuadrature.html).

```math
\int_{-1}^{1} f(x) dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

# Examples
```jldoctest
julia> x, w = gaussradau(3);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ 2/5
true
```

Note that the first node is fixed at -1.

```jldoctest
julia> x, w = gaussradau(3);

julia> x[1]
-1.0
```
"""
function gaussradau(n::Integer, T::Type=Float64)
    a = b = zero(T)
    # RADAUPTS   Gauss-Legendre-Radau Quadrature Nodes and Weights
    if n == 1
        return T[-1], T[2]
    elseif n == 2
        return [-1, one(T)/3], [one(T)/2, convert(T,3)/2]
    else
        # Compute via GaussJacobi:
        x, w = gaussjacobi(n - 1, a, b+1)
        @inbounds for i in 1:length(w)
            w[i] = w[i] / (1 + x[i])
        end
        pushfirst!(x, -1)
        pushfirst!(w, convert(T, 2) / n^2)
        return x, w
    end
end

function gaussradau(n::Integer, α, β)
    if n ≤ 0
        throw(DomainError(n, "Input N must be a positive integer"))
    end
    m = n - 1
    s = α + β
    T = float(eltype(s))
    μ = jacobimoment(α, β)
    n == 0 && return T[], T[]
    n == 1 && return [-one(T)], [μ]
    J = jacobi_jacobimatrix(n, α, β)
    aᴿ = -1 + 2m*convert(T,m+α)/((2m+s)*(2m+s+1))
    J.dv[end] = aᴿ
    x, V = eigen(J)
    w = V[1,:].^2 .* μ
    x[1] = -1 # fix rounding from eigen computation
    return x, w
end

@testset "Gauss–Jacobi" begin
    @testset "check error" begin
        @test_throws DomainError gaussjacobi(-1, 0.1, 0.1)
        @test_throws DomainError gaussjacobi(-1, -1.1, 0.1)
        @test_throws DomainError gaussjacobi(-1, 0.1, -1.1)
    end

    tol = 1e-14
    tol_x = 4e-15
    tol_w = 1e-13

    n_range = vcat(0:10, 20:10:100, 120:20,300)

    @testset "compatible with Gauss-Legendre" begin
        α₀ = 0.0
        β₀ = 0.0
        α₊ = nextfloat(α₀)
        β₊ = nextfloat(β₀)
        α₋ = prevfloat(α₀)
        β₋ = prevfloat(β₀)
        for n in n_range
            x, w = gausslegendre(n)
            x₀₀, w₀₀ = gaussjacobi(n, α₀, β₀)
            x₀₊, w₀₊ = gaussjacobi(n, α₀, β₊)
            x₀₋, w₀₋ = gaussjacobi(n, α₀, β₋)
            x₊₀, w₊₀ = gaussjacobi(n, α₊, β₀)
            x₊₊, w₊₊ = gaussjacobi(n, α₊, β₊)
            x₊₋, w₊₋ = gaussjacobi(n, α₊, β₋)
            x₋₀, w₋₀ = gaussjacobi(n, α₋, β₀)
            x₋₊, w₋₊ = gaussjacobi(n, α₋, β₊)
            x₋₋, w₋₋ = gaussjacobi(n, α₋, β₋)
            for _w in (w₀₀, w₀₊, w₀₋, w₊₀, w₊₊, w₊₋, w₋₀, w₋₊, w₋₋)
                @test norm(w - _w) < tol_w
            end
            for _x in (x₀₀, x₀₊, x₀₋, x₊₀, x₊₊, x₊₋, x₋₀, x₋₊, x₋₋)
                @test norm(x - _x) < tol_x
            end
        end
    end

    @testset "compatible with Gauss-Chebyshev of the 1st kind" begin
        α₀ = -1/2
        β₀ = -1/2
        α₊ = nextfloat(α₀)
        β₊ = nextfloat(β₀)
        α₋ = prevfloat(α₀)
        β₋ = prevfloat(β₀)
        for n in n_range
            x, w = @test_deprecated gausschebyshev(n, 1)
            x₀₀, w₀₀ = gaussjacobi(n, α₀, β₀)
            x₀₊, w₀₊ = gaussjacobi(n, α₀, β₊)
            x₀₋, w₀₋ = gaussjacobi(n, α₀, β₋)
            x₊₀, w₊₀ = gaussjacobi(n, α₊, β₀)
            x₊₊, w₊₊ = gaussjacobi(n, α₊, β₊)
            x₊₋, w₊₋ = gaussjacobi(n, α₊, β₋)
            x₋₀, w₋₀ = gaussjacobi(n, α₋, β₀)
            x₋₊, w₋₊ = gaussjacobi(n, α₋, β₊)
            x₋₋, w₋₋ = gaussjacobi(n, α₋, β₋)
            for _w in (w₀₀, w₀₊, w₀₋, w₊₀, w₊₊, w₊₋, w₋₀, w₋₊, w₋₋)
                @test norm(w - _w) < tol_w
            end
            for _x in (x₀₀, x₀₊, x₀₋, x₊₀, x₊₊, x₊₋, x₋₀, x₋₊, x₋₋)
                @test norm(x - _x) < tol_x
            end
        end
    end

    @testset "compatible with Gauss-Chebyshev of the 2nd kind" begin
        α₀ = 1/2
        β₀ = 1/2
        α₊ = nextfloat(α₀)
        β₊ = nextfloat(β₀)
        α₋ = prevfloat(α₀)
        β₋ = prevfloat(β₀)
        for n in n_range
            x, w = @test_deprecated gausschebyshev(n, 2)
            x₀₀, w₀₀ = gaussjacobi(n, α₀, β₀)
            x₀₊, w₀₊ = gaussjacobi(n, α₀, β₊)
            x₀₋, w₀₋ = gaussjacobi(n, α₀, β₋)
            x₊₀, w₊₀ = gaussjacobi(n, α₊, β₀)
            x₊₊, w₊₊ = gaussjacobi(n, α₊, β₊)
            x₊₋, w₊₋ = gaussjacobi(n, α₊, β₋)
            x₋₀, w₋₀ = gaussjacobi(n, α₋, β₀)
            x₋₊, w₋₊ = gaussjacobi(n, α₋, β₊)
            x₋₋, w₋₋ = gaussjacobi(n, α₋, β₋)
            for _w in (w₀₀, w₀₊, w₀₋, w₊₀, w₊₊, w₊₋, w₋₀, w₋₊, w₋₋)
                @test norm(w - _w) < tol_w
            end
            for _x in (x₀₀, x₀₊, x₀₋, x₊₀, x₊₊, x₊₋, x₋₀, x₋₊, x₋₋)
                @test norm(x - _x) < tol_x
            end
        end
    end

    @testset "compatible with Gauss-Chebyshev of the 3rd kind" begin
        α₀ = -1/2
        β₀ = 1/2
        α₊ = nextfloat(α₀)
        β₊ = nextfloat(β₀)
        α₋ = prevfloat(α₀)
        β₋ = prevfloat(β₀)
        for n in n_range
            x, w = @test_deprecated gausschebyshev(n, 3)
            x₀₀, w₀₀ = gaussjacobi(n, α₀, β₀)
            x₀₊, w₀₊ = gaussjacobi(n, α₀, β₊)
            x₀₋, w₀₋ = gaussjacobi(n, α₀, β₋)
            x₊₀, w₊₀ = gaussjacobi(n, α₊, β₀)
            x₊₊, w₊₊ = gaussjacobi(n, α₊, β₊)
            x₊₋, w₊₋ = gaussjacobi(n, α₊, β₋)
            x₋₀, w₋₀ = gaussjacobi(n, α₋, β₀)
            x₋₊, w₋₊ = gaussjacobi(n, α₋, β₊)
            x₋₋, w₋₋ = gaussjacobi(n, α₋, β₋)
            for _w in (w₀₀, w₀₊, w₀₋, w₊₀, w₊₊, w₊₋, w₋₀, w₋₊, w₋₋)
                @test norm(w - _w) < tol_w
            end
            for _x in (x₀₀, x₀₊, x₀₋, x₊₀, x₊₊, x₊₋, x₋₀, x₋₊, x₋₋)
                @test norm(x - _x) < tol_x
            end
        end
    end

    @testset "compatible with Gauss-Chebyshev of the 4th kind" begin
        α₀ = 1/2
        β₀ = -1/2
        α₊ = nextfloat(α₀)
        β₊ = nextfloat(β₀)
        α₋ = prevfloat(α₀)
        β₋ = prevfloat(β₀)
        for n in n_range
            x, w = @test_deprecated gausschebyshev(n, 4)
            x₀₀, w₀₀ = gaussjacobi(n, α₀, β₀)
            x₀₊, w₀₊ = gaussjacobi(n, α₀, β₊)
            x₀₋, w₀₋ = gaussjacobi(n, α₀, β₋)
            x₊₀, w₊₀ = gaussjacobi(n, α₊, β₀)
            x₊₊, w₊₊ = gaussjacobi(n, α₊, β₊)
            x₊₋, w₊₋ = gaussjacobi(n, α₊, β₋)
            x₋₀, w₋₀ = gaussjacobi(n, α₋, β₀)
            x₋₊, w₋₊ = gaussjacobi(n, α₋, β₊)
            x₋₋, w₋₋ = gaussjacobi(n, α₋, β₋)
            for _w in (w₀₀, w₀₊, w₀₋, w₊₀, w₊₊, w₊₋, w₋₀, w₋₊, w₋₋)
                @test norm(w - _w) < tol_w
            end
            for _x in (x₀₀, x₀₊, x₀₋, x₊₀, x₊₊, x₊₋, x₋₀, x₋₊, x₋₋)
                @test norm(x - _x) < tol_x
            end
        end
    end

    @testset "a small n" begin
        n = 42
        a = -.1
        b = .3
        x, w = gaussjacobi(n, a, b)
        @test all(length(x) == n) && all(length(w) == n)
        @test abs(x[37] - 0.912883347814032) < tol
        @test abs(w[37] - 0.046661910947553) < tol

        @test dot(w,exp.(x)) ≈ 2.7568520361985516
    end
    @testset "a larger n (using ASY)" begin
        a = -.7
        b = 1.3
        n = 251
        x, w = gaussjacobi(n, a, b)
        @test all(length(x) == n) && all(length(w) == n)
        @test abs(x[37] + 0.893103435898983) < tol
        @test abs(w[37] - 1.962534523788093e-04) < tol

        @test dot(w,exp.(x)) ≈ 16.722957039404044
    end
    @testset "n = 1:" begin
        a = 1.0
        b = 2.0
        x, w = gaussjacobi(1, a, b)
        @test abs(x[1] - (b - a) / (a + b + 2)) < tol
        @test abs(w[1] - 2^(a + b + 1) * beta(a + 1, b + 1)) < tol

        @test dot(w,fill(1,length(x))) ≈ 1.3333333333333333
    end
    @testset "0.9, -0.1" begin
        x, w = gaussjacobi(1013, .9, -.1)
        @test abs(x[2] + 0.999986012231899) < tol
        @test abs(x[13] + 0.999225722939832) < tol
        @test abs(w[2] - 9.314674169892358e-05) < tol
        @test abs(w[13] - 4.654651764553262e-04) < tol

        @test dot(w,exp.(x)) ≈ 1.6915068974063106

        x, w = gaussjacobi(10013, .9, -.1)
        @test abs(x[2]  +0.999999856605293) < tol
        @test abs(x[13]  + 0.999992061552711) < tol
        @test abs(w[2] - 1.509654630405615e-06) < tol
        @test abs(w[13] - 7.548275262993863e-06) < tol

        @test dot(w,exp.(x)) ≈ 1.6915068974063106
    end
    @testset "bug where row vectors were returned" begin
        x, w = gaussjacobi(10013, .9, -.1)
        @test isa(x,Vector{Float64})
        @test isa(w,Vector{Float64})
    end
    @testset "last alpha and beta parameters:" begin
        x, w = gaussjacobi(100, 19., 21.)
        @test abs(x[87] - 0.832211446176040) < tol
        @test abs(w[50] - 0.026363584978877305) < tol # new test without condition sum(w)==1
    end
    @testset "for small alpha and beta:" begin
        x, w = gaussjacobi(10000, .1, .2)
        @test abs(x[1] - -0.999999963363548) < tol
        @test abs(w[500] - 2.183393039546711e-05) < tol
    end
    @testset " bug where row vectors were returned" begin
        x,w=gaussjacobi(20,11.,0.)
        @test isa(x,Vector{Float64})
        @test isa(w,Vector{Float64})
    end
    @testset "missing promotion with integers (#117)" begin
        x1, w1 = gaussjacobi(500, 0, -1/2)
        x2, w2 = gaussjacobi(500, 0.0, -1/2)
        @test x1 == x2
        @test w1 == w2
    end

    @testset "jacobi_rec against a precomputed rule in BigFloat" begin
        x,w = FastGaussQuadrature.jacobi_rec(10, big(0), big(0))
        @test abs(x[6] - big(1488743389816312108848260011297199846175648594206916957079892535159036173556674)/big(10)^79) < 1e-70
        @test abs(w[4] - big(2692667193099963550912269215694693528597599384608837958005632762421534323191819)/big(10)^79) < 1e-70

        x,w = FastGaussQuadrature.jacobi_rec(10, big(2//10), big(-1//30))
        @test abs(x[7] - big(4146701176053244724446765533149623814305606864483746748725151214196203624388371)/big(10)^79) < 1e-70
        @test abs(w[3] - big(2482452398859023537636458227096017466104571146686194593251519240011574719667464)/big(10)^79) < 1e-70
    end

    @testset "boundary asymptotics were previously not implemented (#58,#130)" begin
        # check example from issue #58
        _, w = gaussjacobi(2^10, 0.25, 0)
        @test abs(w[end] - 3.607554904604311e-07) < tol

        # check example from issue #130
        _, w = gaussjacobi(2^16, -0.9, 0)
        @test abs(w[end] - 1.223027243345722) < tol
        @test abs(sum(w) - 2^(-0.9+1)/(-0.9+1)) < tol

        # double check NaN fixing in barycentric interpolation implementation
        x  = range(0, stop=1, length=5)
        N  = 10
        fvals = ones(N)
        xk = .5*(sin.(pi*(-(N-1):2:(N-1))/(2*(N-1))) .+ 1)
        vk = [.5; ones(N-1)]
        vk[2:2:end] .= -1
        vk[end]     *= .5
        @test FastGaussQuadrature.bary(x, fvals, xk, vk) ≈ ones(5) rtol=1e-16
    end
end

@doc raw"""
    gausschebyshevt(n::Integer) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of [Gauss-Chebyshev quadrature](https://en.wikipedia.org/wiki/Chebyshev%E2%80%93Gauss_quadrature) of the 1st kind.

```math
\int_{-1}^{1} \frac{f(x)}{\sqrt{1-x^2}} dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

# Examples
```jldoctest
julia> x, w = gausschebyshevt(3);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ 3π/8
true
```
"""
function gausschebyshevt(n::Integer)
    if n < 0
        throw(DomainError(n, "Input n must be a non-negative integer"))
    end
    return [cos((2 * k - 1) * π / (2 * n)) for k = n:-1:1], fill(π / n, n)
end

@doc raw"""
    gausschebyshevu(n::Integer) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of [Gauss-Chebyshev quadrature](https://en.wikipedia.org/wiki/Chebyshev%E2%80%93Gauss_quadrature) of the 2nd kind.

```math
\int_{-1}^{1} f(x)\sqrt{1-x^2} dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

# Examples
```jldoctest
julia> x, w = gausschebyshevu(3);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ π/16
true
```
"""
function gausschebyshevu(n::Integer)
    if n < 0
        throw(DomainError(n, "Input n must be a non-negative integer"))
    end
    return [cos(k * π / (n + 1)) for k = n:-1:1], [π/(n + 1) * sin(k / (n + 1) * π)^2 for k = n:-1:1]
end

@doc raw"""
    gausschebyshevv(n::Integer) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of [Gauss-Chebyshev quadrature](https://en.wikipedia.org/wiki/Chebyshev%E2%80%93Gauss_quadrature) of the 3rd kind.

```math
\int_{-1}^{1} f(x)\sqrt{\frac{1+x}{1-x}} dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

# Examples
```jldoctest
julia> x, w = gausschebyshevv(3);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ 3π/8
true
```
"""
function gausschebyshevv(n::Integer)
    if n < 0
        throw(DomainError(n, "Input n must be a non-negative integer"))
    end
    return [cos((k - .5) * π / (n + .5)) for k = n:-1:1], [2π / (n + .5) * cos((k - .5) * π / (2 * (n + .5)))^2 for k = n:-1:1]
end

@doc raw"""
    gausschebyshevw(n::Integer) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of [Gauss-Chebyshev quadrature](https://en.wikipedia.org/wiki/Chebyshev%E2%80%93Gauss_quadrature) of the 4th kind.

```math
\int_{-1}^{1} f(x)\sqrt{\frac{1-x}{1+x}} dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

# Examples
```jldoctest
julia> x, w = gausschebyshevw(3);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ 3π/8
true
```
"""
function gausschebyshevw(n::Integer)
    if n < 0
        throw(DomainError(n, "Input n must be a non-negative integer"))
    end
    return [cos(k * π / (n + .5)) for k = n:-1:1], [2π / (n + .5) * sin(k * π / (2 * (n + .5)))^2 for k = n:-1:1]
end

function gausschebyshev(n::Integer, kind::Integer=1)
    # GAUSS-CHEBYSHEV NODES AND WEIGHTS.

    if n < 0
        throw(DomainError(n, "Input n must be a non-negative integer"))
    end

    # Use known explicit formulas. Complexity O(n).
    if kind == 1
        # Gauss-Chebyshevt quadrature, i.e., w(x) = 1/sqrt(1-x^2)
        Base.depwarn("`gausschebyshev(n, 1)` is deprecated and will be removed in the next breaking release. Please use `gausschebyshevt(n)` instead.", :gausschebyshev)
        return gausschebyshevt(n)
    elseif kind == 2
        # Gauss-Chebyshevu quadrature, i.e., w(x) = sqrt(1-x^2)
        Base.depwarn("`gausschebyshev(n, 2)` is deprecated and will be removed in the next breaking release. Please use `gausschebyshevu(n)` instead.", :gausschebyshev)
        return gausschebyshevu(n)
    elseif kind == 3
        # Gauss-Chebyshevv quadrature, i.e., w(x) = sqrt((1+x)/(1-x))
        Base.depwarn("`gausschebyshev(n, 3)` is deprecated and will be removed in the next breaking release. Please use `gausschebyshevv(n)` instead.", :gausschebyshev)
        return gausschebyshevv(n)
    elseif kind == 4
        # Gauss-Chebyshevw quadrature, i.e., w(x) = sqrt((1-x)/(1+x))
        Base.depwarn("`gausschebyshev(n, 4)` is deprecated and will be removed in the next breaking release. Please use `gausschebyshevw(n)` instead.", :gausschebyshev)
        return gausschebyshevw(n)
    else
        throw(ArgumentError("Chebyshev kind should be 1, 2, 3, or 4"))
    end
end

module FastGaussQuadrature

using LinearAlgebra
using SpecialFunctions
using StaticArrays

export gausslegendre
export gausschebyshev
export gausschebyshevt
export gausschebyshevu
export gausschebyshevv
export gausschebyshevw
export gausslaguerre
export gausshermite
export gaussjacobi
export gausslobatto
export gaussradau
export approx_besselroots
export besselroots

import SpecialFunctions: besselj, airyai, airyaiprime

include("constants.jl")
include("gausslegendre.jl")
include("gausschebyshev.jl")
include("gausslaguerre.jl")
include("gausshermite.jl")
include("gaussjacobi.jl")
include("gausslobatto.jl")
include("gaussradau.jl")
include("besselroots.jl")

end

@doc raw"""
    gausslobatto(n::Integer) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of [Gauss-Lobatto quadrature](https://mathworld.wolfram.com/LobattoQuadrature.html).

```math
\int_{-1}^{1} f(x) dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

# Examples
```jldoctest
julia> x, w = gausslobatto(4);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ 2/5
true
```

Note that the both ends of nodes are fixed at -1 and 1.

```jldoctest
julia> x, w = gausslobatto(4);

julia> x[1], x[end]
(-1.0, 1.0)
```
"""
function gausslobatto(n::Integer)
    # Gauss-Legendre-Lobatto Quadrature Nodes and Weights
    if n ≤ 1
        throw(DomainError(n, "Lobatto undefined for n ≤ 1."))
    elseif n == 2
        return [-1.0, 1.0], [1.0, 1.0]
    elseif n == 3
        return [-1.0, 0.0, 1.0], [1.0 / 3, 4.0 / 3, 1.0 / 3]
    else
        # Compute via GaussJacobi:
        x, w = gaussjacobi(n - 2, 1.0, 1.0)
        @inbounds for i in 1:length(x)
            w[i] = w[i] / (1 - x[i]^2)
        end
        pushfirst!(x, -1.0)
        push!(x, 1.0)
        pushfirst!(w, 2 / (n * (n - 1)))
        push!(w, 2 / (n * (n - 1)))
        return x, w
    end
end

@testset "Gauss–Hermite" begin
    @testset "Check error" begin
        @test_throws DomainError gausshermite(-1)
    end

    @testset "Small n case" begin
        @test gausshermite(0) == (Float64[], Float64[])
        x, w = gausshermite(1)
        @test x ≈ [0.0]
        @test w ≈ [√π]
    end

    tol = 1.0e-14

    @testset "Golub-Welsch" begin
        n = 18
        x, w = gausshermite(n)
        @test isa(x, Vector{Float64})
        @test isa(w, Vector{Float64})
        @test (length(x) == n && length(w) == n)
        @test (dot(w, x) < tol && abs(dot(w, x .^ 2) - sqrt(π) / 2) < tol)
    end

    @testset "Recurrence" begin
        n = 42
        x, w = gausshermite(n)
        @test isa(x, Vector{Float64})
        @test isa(w, Vector{Float64})
        @test (length(x) == n && length(w) == n)
        @test (dot(w, x) < tol && abs(dot(w, x .^ 2) - sqrt(π) / 2) < tol)
        @test abs(x[37] - 5.660357581283058) < tol
        @test abs(w[17] - 0.032202101288908) < tol

        f = x -> 1 + x + x^2 + x^3
        @test w'f.(x) ≈ 2.6586807763789717
    end

    @testset "Asymptotics"  begin
        n = 251
        x, w = gausshermite(n)
        @test isa(x, Vector{Float64})
        @test isa(w, Vector{Float64})
        @test (length(x) == n && length(w) == n)
        @test (dot(w, x) < tol && abs(dot(w, x .^ 2) - sqrt(π) / 2) < 300 * tol)
        @test abs(x[37] - -13.292221459334638) < tol
        @test abs(w[123] - 0.117419270715955) < 2 * tol

        n = 500
        x, w = gausshermite(n)
        @test isa(x, Vector{Float64})
        @test isa(w, Vector{Float64})
        @test (length(x) == n && length(w) == n)
        @test (dot(w, x) < tol && abs(dot(w, x .^ 2) - sqrt(π) / 2) < 300 * tol)
    end

    @testset "Recurrence" begin
        x = 0.1
        He0 = 1 # Probabilists He_n(x) = H_n(x/sqrt(2))/2^(n/2)
        He1 = x; He2 = x^2 - 1; He3 = x * (x^2 - 3); He4 = 3 - 6x^2 + x^4
        @test FastGaussQuadrature.hermpoly_rec(1, x)[1] ≈ He1 * exp(-x^2 / 4)
        @test FastGaussQuadrature.hermpoly_rec(2, x)[1] ≈ He2 * exp(-x^2 / 4) / sqrt(2)
        @test FastGaussQuadrature.hermpoly_rec(3, x)[1] ≈ He3 * exp(-x^2 / 4) / sqrt(2 * 3)
        @test FastGaussQuadrature.hermpoly_rec(4, x)[1] ≈ He4 * exp(-x^2 / 4) / sqrt(2 * 3 * 4)

        @test FastGaussQuadrature.hermpoly_rec(1, 60)[1] ≈ 0.0
        @test FastGaussQuadrature.hermpoly_rec(20^2, 20)[1] ≈ 0.20019391063012504
        @test FastGaussQuadrature.hermpoly_rec(60^2, 60)[1] ≈ 0.07918022667865038
        @test FastGaussQuadrature.hermpoly_rec(60^2, 100)[1] ≈ -0.14191347555044895
        @test FastGaussQuadrature.hermpoly_rec(60^2, 130)[1] ≈ 1.7334093012299562e-73
        @test FastGaussQuadrature.hermpoly_rec(60^2, 200)[1] ≈ 0.0

        @test FastGaussQuadrature.hermpoly_rec(1:9, x) ≈ [FastGaussQuadrature.hermpoly_rec(n, x)[1] for n in 1:9]
        @test FastGaussQuadrature.hermpoly_rec(0:(20^2), 20)[end] ≈ FastGaussQuadrature.hermpoly_rec(20^2, 20)[1]
    end

    @testset "Type inference" begin
        @inferred gausshermite(Float32, 10)
        @inferred gausshermite(BigFloat, 10)
        @inferred gausshermite(BigFloat, 250)
    end

    @testset "Normalize" begin
        for t in 1:6
            x, w = gausshermite(t; normalize = true)
            N = 2t - 1
            v = 1.0
            for n in 2:2:N
                v *= (n - 1)
                @test v ≈ dot(x .^ n, w)
            end
            for n in 1:2:N
                @test abs(0.0 - dot(x .^ n, w)) < 10 * tol
            end
        end
    end

    @testset "All" begin
        for n in 2:220
            x, w = gausshermite(n)
            @test isa(x, Vector{Float64})
            @test isa(w, Vector{Float64})
            @test (length(x) == n && length(w) == n)
            # The tol should be large for large n.
            @test (dot(w, x) < tol && abs(dot(w, x .^ 2) - sqrt(π) / 2) < 1000 * tol)
        end
    end

    @testset "Transform" begin
        n = 500
        x, w = FastGaussQuadrature.unweightedgausshermite(n)
        @test w[1] ≠ 0

        V = Array{Float64}(undef, n, n)
        for k in 1:n
            V[k, :] = FastGaussQuadrature.hermpoly_rec(0:(n - 1), sqrt(2) * x[k])
        end

        f = x -> first(FastGaussQuadrature.hermpoly_rec(1, sqrt(2) * x))
        @test V' * (w .* f.(x)) ≈ [0; sqrt(π); zeros(n - 2)]
        f = x -> first(FastGaussQuadrature.hermpoly_rec(2, sqrt(2) * x))
        @test V' * (w .* f.(x)) ≈ [0; 0; sqrt(π); zeros(n - 3)]
        f = x -> first(FastGaussQuadrature.hermpoly_rec(3, sqrt(2) * x))
        @test V' * (w .* f.(x)) ≈ [0; 0; 0; sqrt(π); zeros(n - 4)]
    end
end

@doc raw"""
    gausshermite([T=Float64,] n::Integer; normalize = false) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of [Gauss-Hermite quadrature](https://en.wikipedia.org/wiki/Gauss%E2%80%93Hermite_quadrature) with type `T`.

```math
\int_{-\infty}^{+\infty} f(x) \exp(-x^2) dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

The option `normalize=true` instead computes
```math
\int_{-\infty}^{+\infty} f(x) \phi(x) dx \approx \sum_{i=1}^{n} w_i f(x_i),
```
where $\phi$ is the standard normal density function.

# Examples
```jldoctest
julia> x, w = gausshermite(3);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ 3(√π)/4
true
```
"""
function gausshermite(::Type{T}, n::Integer; normalize = false) where {T}
    x, w = unweightedgausshermite(T, n)
    w .*= exp.(-x .^ 2)
    return normalize ? (sqrt(T(2)) * x, w / sqrt(T(π))) : (x, w)
end
gausshermite(n::Integer; normalize = false) = gausshermite(Float64, n; normalize = normalize)

function unweightedgausshermite(::Type{T}, n::Integer) where {T <: Real}
    # GAUSSHERMITE(n) COMPUTE THE GAUSS-HERMITE NODES AND WEIGHTS IN O(n) time.
    if n < 0
        throw(DomainError(n, "Input n must be a non-negative integer"))
    elseif n == 0
        return T[], T[]
    elseif n == 1
        return T[0], T[sqrt(T(π))]
    elseif n ≤ 20
        # GW algorithm
        x = hermite_gw(T, n)
    elseif n ≤ 200 || T != Float64
        # REC algorithm
        x = hermite_rec(T, n)
    else
        # ASY algorithm
        x = hermite_asy(n)
    end

    # fold out
    if isodd(n)
        _w = [reverse(x[2][:]); x[2][2:end]]
        _x = [-reverse(x[1]) ; x[1][2:end]]
    else
        _w = [reverse(x[2][:]); x[2][:]]
        _x = [-reverse(x[1]) ; x[1]]
    end
    _w .*= sqrt(T(π)) / sum(exp.(-_x .^ 2) .* _w)

    return _x, _w
end
unweightedgausshermite(n::Integer) = unweightedgausshermite(Float64, n)

function hermite_asy(n::Integer)
    # Compute Hermite nodes and weights using asymptotic formula

    x0 = hermite_initialguess(n)  # get initial guesses
    t0 = x0 ./ sqrt(2n + 1)
    θ = acos.(t0)  # convert to θ-variable
    val = x0
    for _ in 1:20
        val = hermpoly_asy_airy(n, θ)
        dθ = -val[1] ./ (sqrt(2) .* sqrt(2n + 1) .* val[2] .* sin.(θ))
        θ .-= dθ  # Newton update
        if norm(dθ, Inf) < sqrt(eps(Float64)) / 10
            break
        end
    end
    t0 = cos.(θ)
    x = sqrt(2n + 1) * t0  #back to x-variable
    w = x .* val[1] .+ sqrt(2) .* val[2]
    w .= 1 ./ w .^ 2  # quadrature weights

    return x, w
end

function hermite_rec(::Type{T}, n::Integer) where {T <: AbstractFloat}
    # Compute Hermite nodes and weights using recurrence relation.

    x0 = T.(hermite_initialguess(n))
    x0 .*= sqrt(T(2))
    val = x0
    num_iters = T == Float64 ? 10 : ceil(Int, (log(max(20, precision(T)) / 50) + 1) * 10)
    for _ in 1:num_iters
        val = hermpoly_rec.(n, x0)
        dx = first.(val) ./ last.(val)
        dx[isnan.(dx)] .= 0
        x0 .= x0 .- dx
        if norm(dx, Inf) < sqrt(eps(T))
            break
        end
    end
    x0 ./= sqrt(T(2))
    w = 1 ./ last.(val) .^ 2  # quadrature weights

    return x0, w
end

function hermpoly_rec(n::Integer, x0)
    # HERMPOLY_rec evaluation of scaled Hermite poly using recurrence
    n < 0 && throw(DomainError(n, "Input n must be a non-negative integer"))
    # evaluate:
    w = exp(-x0^2 / (4 * n))
    wc = 0 # 0 times we've applied wc
    Hold = one(x0)
    # n == 0 && return (Hold, 0)
    H = x0
    for k in 1:(n - 1)
        Hold, H = H, (x0 * H / sqrt(oftype(x0, k + 1)) - Hold / sqrt(oftype(x0, k + 1) / k))
        while abs(H) ≥ 100 && wc < n  # regularise
            H *= w
            Hold *= w
            wc += 1
        end
        k += 1
    end
    for _ in (wc + 1):n
        H *= w
        Hold *= w
    end

    return H, -x0 * H + sqrt(oftype(x0, n)) * Hold
end

function hermpoly_rec(r::Base.OneTo, x0)
    isempty(r) && return [1.0]
    n = maximum(r)
    # HERMPOLY_rec evaluation of scaled Hermite poly using recurrence
    n < 0 && throw(DomainError(n, "Input n must be a non-negative integer"))
    n == 0 && return [exp(-x0^2 / 4)]
    p = max(1, floor(Int, x0^2 / 100))
    w = exp(-x0^2 / 4p)
    wc = 0 # 0 times we've applied wc
    ret = Vector{Float64}()
    Hold = one(x0)
    push!(ret, Hold)
    H = x0
    push!(ret, H)
    for k in 1:(n - 1)
        Hold, H = H, (x0 * H / sqrt(k + 1) - Hold / sqrt(1 + 1 / k))
        while abs(H) ≥ 100 && wc < p  # regularise
            ret .*= w
            H *= w
            Hold *= w
            wc += 1
        end
        push!(ret, H)
        k += 1
    end
    ret .*= w^(p - wc)

    return ret
end

hermpoly_rec(r::AbstractRange, x0) = hermpoly_rec(Base.OneTo(maximum(r)), x0)[r .+ 1]

function hermpoly_asy_airy(n::Integer, θ::AbstractVector)
    # HERMPOLY_ASY evaluation hermite poly using Airy asymptotic formula in θ-space.

    musq = 2n + 1
    cosT = cos.(θ)
    sinT = sin.(θ)
    sin2T = 2 .* cosT .* sinT
    η = 0.5 .* θ .- 0.25 .* sin2T
    χ = -(3 * η / 2) .^ (2 / 3)
    φ = (-χ ./ sinT .^ 2) .^ (1 / 4)
    C = 2 * sqrt(π) * musq^(1 / 6) * φ
    Airy0 = real.(airyai.(musq .^ (2 / 3) .* χ))
    Airy1 = real.(airyaiprime.(musq .^ (2 / 3) .* χ))

    # Terms in (12.10.43):
    a0 = 1
    b0 = 1
    a1 = 15 / 144
    b1 = -7 / 5 * a1
    a2 = 5 * 7 * 9 * 11 / 2 / 144^2
    b2 = -13 / 11 * a2
    a3 = 7 * 9 * 11 * 13 * 15 * 17 / 6 / 144^3
    b3 = -19 / 17 * a3

    # u polynomials in (12.10.9)
    u0 = 1
    u1 = (cosT .^ 3 - 6 * cosT) / 24
    u2 = (-9 * cosT .^ 4 + 249 * cosT .^ 2 .+ 145) / 1152
    u3 = (-4042 * cosT .^ 9 + 18189 * cosT .^ 7 - 28287 * cosT .^ 5 - 151995 * cosT .^ 3 - 259290 * cosT) / 414720

    # first term
    A0 = 1
    val = A0 * Airy0

    # second term
    B0 = -(a0 * u1 .* φ .^ 6 .+ a1 * u0) ./ χ .^ 2
    val .+= B0 .* Airy1 ./ musq .^ (4 / 3)

    # third term
    A1 = (b0 * u2 .* φ .^ 12 + b1 * u1 .* φ .^ 6 .+ b2 * u0) ./ χ .^ 3
    val .+= A1 .* Airy0 / musq .^ 2

    # fourth term
    B1 = -(u3 .* φ .^ 18 + a1 * u2 .* φ .^ 12 + a2 * u1 .* φ .^ 6 .+ a3 * u0) ./ χ .^ 5
    val .+= B1 .* Airy1 ./ musq .^ (4 / 3 + 2)

    val .= C .* val

    ## Derivative
    η = 0.5 * θ - 0.25 * sin2T
    χ = -(3 * η / 2) .^ (2 / 3)
    φ = (-χ ./ sinT .^ 2) .^ (1 / 4)
    C = sqrt(2 * π) * musq^(1 / 3) ./ φ

    # v polynomials in (12.10.10)
    v0 = 1
    v1 = (cosT .^ 3 + 6cosT) / 24
    v2 = (15 * cosT .^ 4 - 327 * cosT .^ 2 .- 143) / 1152
    v3 = (259290 * cosT + 238425 * cosT .^ 3 - 36387 * cosT .^ 5 + 18189 * cosT .^ 7 - 4042 * cosT .^ 9) / 414720

    # first term
    C0 = -(b0 * φ .^ 6 .* v1 .+ b1 .* v0) ./ χ
    dval = C0 .* Airy0 / musq .^ (2 / 3)

    # second term
    D0 = a0 * v0
    dval = dval + D0 * Airy1

    # third term
    C1 = -(v3 .* φ .^ 18 + b1 * v2 .* φ .^ 12 + b2 * v1 .* φ .^ 6 .+ b3 * v0) ./ χ .^ 4
    dval = dval + C1 .* Airy0 / musq .^ (2 / 3 + 2)

    # fourth term
    D1 = (a0 * v2 .* φ .^ 12 + a1 * v1 .* φ .^ 6 .+ a2 * v0) ./ χ .^ 3
    dval = dval + D1 .* Airy1 / musq .^ 2

    dval = C .* dval

    return val, dval
end

function hermite_initialguess(n::Integer)
    # HERMITEINTITIALGUESSES(N), Initial guesses for Hermite zeros.
    #
    # [1] L. Gatteschi, Asymptotics and bounds for the zeros of Laguerre
    # polynomials: a survey, J. Comput. Appl. Math., 144 (2002), pp. 7-27.
    #
    # [2] F. G. Tricomi, Sugli zeri delle funzioni di cui si conosce una
    # rappresentazione asintotica, Ann. Mat. Pura Appl. 26 (1947), pp. 283-300.

    # Error if n < 20 because initial guesses are based on asymptotic expansions:
    @assert n ≥ 20

    # Gatteschi formula involving airy roots [1].
    # These initial guess are good near x = sqrt(n+1/2);
    if isodd(n)
        m = (n - 1) >> 1
        # bess = (1:m)*π
        a = 0.5
    else
        m = n >> 1
        # bess = ((0:m-1) .+ 0.5)*π
        a = -0.5
    end
    ν = 4m + 2a + 2

    T(t) = t^(2 / 3) * (1 + 5 / 48 * t^(-2) - 5 / 36 * t^(-4) + (77125 / 82944) * t^(-6) - 108056875 / 6967296 * t^(-8) + 162375596875 / 334430208 * t^(-10))
    airyrts = -T.(3π / 8 * (4 * (1:m) .- 1))

    airyrts[1:10] .= AIRY_ROOTS[1:10]  # correct first 10.

    x_init = sqrt.(
        abs.(
            ν .+ (2^(2 / 3)) .* airyrts .* ν^(1 / 3) .+ (1 / 5 * 2^(4 / 3)) .* airyrts .^ 2 .* ν^(-1 / 3) .+
                (11 / 35 - a^2 - 12 / 175) .* airyrts .^ 3 ./ ν .+ ((16 / 1575) .* airyrts .+ (92 / 7875) .* airyrts .^ 4) .* 2^(2 / 3) .* ν^(-5 / 3) .-
                ((15152 / 3031875) .* airyrts .^ 5 .+ (1088 / 121275) .* airyrts .^ 2) .* 2^(1 / 3) .* ν^(-7 / 3)
        )
    )
    x_init_airy = reverse(x_init)

    # Tricomi initial guesses. Equation (2.1) in [1]. Originally in [2].
    # These initial guesses are good near x = 0 . Note: zeros of besselj(+/-.5,x)
    # are integer and half-integer multiples of π.
    # x_init_bess =  bess/sqrt(ν).*sqrt((1+ (bess.^2+2*(a^2-1))/3/ν^2) );
    Tnk0 = fill(π / 2, m)
    rhs = ((4m + 3) .- 4 * (1:m)) / ν * π

    for k in 1:7
        val = Tnk0 .- sin.(Tnk0) .- rhs
        dval = 1 .- cos.(Tnk0)
        dTnk0 = val ./ dval
        Tnk0 = Tnk0 .- dTnk0
    end

    tnk = cos.(Tnk0 / 2) .^ 2
    x_init_sin = sqrt.(ν * tnk - ((tnk .+ 1 / 4) ./ (tnk .- 1) .^ 2 .+ (3a^2 - 1)) / 3ν)

    # Patch together
    p = 0.4985 + eps(Float64)
    x_init = [
        x_init_sin[1:convert(Int, floor(p * n))]
        x_init_airy[convert(Int, ceil(p * n)):end]
    ]

    if isodd(n)
        x_init = [0 ; x_init]
        x_init = x_init[1:(m + 1)]
    else
        x_init = x_init[1:m]
    end

    return x_init
end

function hermite_gw(::Type{T}, n::Integer) where {T <: Real}
    # Golub--Welsch algorithm. Used here for n ≤ 20.

    beta = sqrt.(T.(1:(n - 1)) / 2)  # 3-term recurrence coeffs
    J = SymTridiagonal(zeros(T, n), beta)  # Jacobi matrix
    D, V = eigen(J)  # Eigenvalue decomposition
    ind = sortperm(D)  # Hermite points
    x = D[ind]  # nodes
    w = sqrt(T(π)) * V[1, ind] .^ 2  # weights

    # Enforce symmetry:
    i = (floor(Int, n / 2) + 1):n
    x = x[i]
    w = w[i]
    return x, exp.(x .^ 2) .* w
end
hermite_gw(n::Integer) = hermite_gw(Float64, n)

# Test gausslaguerre.jl

# Test integration
tol = 1.0e-13

# Evaluate the exact integral of x^α * p(x) *exp(-x) on the positive halfline,
# where p(x) = sum( coef[i+1]*x^i, i=0..degree(p)) is a polynomial given by its
# monomial coefficients
function exact_integral_poly(α, coef)
    # do calculations in BigFloat precision
    z = big(0.0)
    for i in 1:length(coef)
        z += gamma(big(α)+big(i)) * big(coef[i])
    end
    Float64(z)
end

function polyval(x, coef)
    z = zeros(size(x))
    d = length(coef)-1
    for i in 1:length(x)
        z[i] = sum(coef .* x[i].^(0:d))
    end
    z
end

# Evaluate the exact integral of cos(a*x) * x^α * exp(-x) on the positive halfline
# - For α = 0
exact_integral_cos1(a) = 1/(a^2+1)
# - For α = 1/2
exact_integral_cos2(a) = sqrt(π)*cos(3/2*atan(a))/2 / (a^2+1)^(3/4)

Random.seed!(0)

@testset "Gauss–Laguerre" begin
    # Check error
    @test_throws DomainError gausslaguerre(1, -1.4)
    @test_throws DomainError gausslaguerre(-1)

    # Check optional argument
    for n in 0:20
        @test gausslaguerre(n) == gausslaguerre(n,0) == gausslaguerre(n,0.0)
    end
    for n in 30:10:200
        @test gausslaguerre(n) == gausslaguerre(n,0) == gausslaguerre(n,0.0)
    end

    ##########
    # Test the special cases
    ##########

    x, w = gausslaguerre(0)
    @test x == Float64[]
    @test w == Float64[]

    x, w = gausslaguerre(1, 0.4)
    @test x == [1.4]
    @test w == [gamma(1.4)]

    x, w = gausslaguerre(2, -0.37)
    @test x ≈ [0.35328546651962944; 2.90671453348037]
    @test w ≈ [1.269857265034167; 0.15433992954023468]


    ##########
    n = 42
    ##########
    α = 0.0
    coef = rand(17)
    Z = exact_integral_poly(α, coef)

    x, w = gausslaguerre(n, α)
    @test isa(x, Vector{Float64})
    @test isa(w, Vector{Float64})
    @test abs(sum(w) - 1) < tol
    @test abs(dot(w, x) - 1) < tol
    @test abs(x[37] - 98.388267163326702) < tol
    @test abs(w[7] - 0.055372813167092) < tol
    @test abs(dot(w, polyval(x, coef)) - Z)/abs(Z) < tol

    x_gw, w_gw = FastGaussQuadrature.gausslaguerre_GW(n, α)
    @test abs(x_gw[37] - 98.388267163326702) < tol
    @test abs(w_gw[7] - 0.055372813167092) < tol
    @test abs(dot(w_gw, polyval(x_gw, coef)) - Z)/abs(Z) < tol

    x_rec, w_rec = FastGaussQuadrature.gausslaguerre_rec(n, α)
    @test abs(x_rec[37] - 98.388267163326702) < tol
    @test abs(w_rec[7] - 0.055372813167092) < tol
    @test abs(dot(w_rec, polyval(x_rec, coef)) - Z)/abs(Z) < tol


    α = 0.5
    coef = rand(17)
    Z = exact_integral_poly(α, coef)
    x, w = gausslaguerre(n, α)
    @test abs(dot(w, polyval(x, coef)) - Z)/abs(Z) < tol



    ##########
    n = 251
    ##########
    α = 0.0
    x, w = gausslaguerre(n, α)
    a = 4
    Z = exact_integral_cos1(a)
    @test isa(x, Vector{Float64})
    @test isa(w, Vector{Float64})
    @test abs(x[37] - 13.309000189442097) < tol
    @test abs(w[3] - 0.050091759039996) < tol
    @test abs(dot(w, cos.(a*x)) - Z) < tol

    α = 0.5
    x, w = gausslaguerre(n, α)
    @test abs(x[44] -19.095577327730616 ) < tol
    @test abs(w[18] - 0.026245779174690266) < tol
    a = 4
    Z = exact_integral_cos2(a)
    @test abs(dot(w, cos.(a*x)) - Z) < tol


    ############
    n = 350000
    ############
    α = 0.0
    a = 50
    Z = exact_integral_cos1(a)
    x, w = gausslaguerre(n, α)
    @test isa(x, Vector{Float64})
    @test isa(w, Vector{Float64})
    @test abs(dot(w, cos.(a*x)) - Z) < tol

    α = 0.44
    x, w = gausslaguerre(n, α; reduced = true)
    @test w[end] < 100*floatmin(Float64)
end

@doc raw"""
    approx_besselroots(ν::Real, n::Integer) -> Vector{Float64}

Return the first ``n`` roots of [Bessel function](https://en.wikipedia.org/wiki/Bessel_function).
Note that this function is only 12-digits of precision.

```math
J_{\nu}(x) = \sum_{m=0}^{\infty}\frac{(-1)^j}{\Gamma(\nu+j+1)j!} \left(\frac{x}{2}\right)^{2j+\nu}
```

# Examples
```jldoctest
julia> ν = 0.3;

julia> roots = approx_besselroots(ν, 10);

julia> zeros = (x -> besselj(ν, x)).(roots);

julia> all(zeros .< 1e-12)
true
```
"""
function approx_besselroots(ν::Real, n::Integer)
    # FIXME (related issue #22 and #80)
    return approx_besselroots(Float64(ν), n)
end

function approx_besselroots(ν::Float64, n::Integer)
    # DEVELOPERS NOTES:
    #   ν = 0 --> Full Float64 precision for n ≤ 20 (Wolfram Alpha), and very
    #     accurate approximations for n > 20 (McMahon's expansion)
    #   -1 ≤ ν ≤ 5 : ν ~= 0 --> 12 decimal figures for the 6 first zeros
    #     (Piessens's Chebyshev series approximations), and very accurate
    #     approximations for the others (McMahon's expansion)
    #   ν > 5 --> moderately accurate for the 6 first zeros and good
    #     approximations for the others (McMahon's expansion)

    # This code was originally written by L. L. Peixoto in MATLAB.
    # Later modified by A. Townsend to work in Julia

    if n < 0
        throw(DomainError(n, "Input n must be a non-negative integer"))
    end

    x = zeros(n)
    if ν == 0
        for k in 1:min(n, 20)
            x[k] = BESSELJ0_ROOTS[k]
        end
        for k in (min(n, 20) + 1):n
            x[k] = McMahon(ν, k)
        end
    elseif -1 ≤ ν ≤ 5
        correctFirstFew = piessens(ν)
        for k in 1:min(n, 6)
            x[k] = correctFirstFew[k]
        end
        for k in (min(n, 6) + 1):n
            x[k] = McMahon(ν, k)
        end
    elseif 5 < ν
        for k in 1:n
            x[k] = McMahon(ν, k)
        end
    end
    return x
end

function McMahon(ν::Real, k::Integer)
    # FIXME (related issue #22 and #80)
    return McMahon(Float64(ν), k)
end

function McMahon(ν::Float64, k::Integer)
    # McMahon's expansion. This expansion gives very accurate approximation
    # for the sth zero (s ≥ 7) in the whole region ν ≥ -1, and moderate
    # approximation in other cases.
    μ = 4ν^2
    a1 = 1 / 8
    a3 = (7μ - 31) / 384
    a5 = 4 * (3779 + μ * (-982 + 83μ)) / 61440 # Evaluate via Horner's method.
    a7 = 6 * (-6277237 + μ * (1585743 + μ * (-153855 + 6949μ))) / 20643840
    a9 = 144 * (2092163573 + μ * (-512062548 + μ * (48010494 + μ * (-2479316 + 70197μ)))) / 11890851840
    a11 = 720 * (
        -8249725736393 + μ * (
            1982611456181 + μ * (
                -179289628602 + μ * (
                    8903961290 + μ * (
                        -287149133 + μ * (
                            5592657
                        )
                    )
                )
            )
        )
    ) / 10463949619200
    a13 = 576 * (
        423748443625564327 + μ * (
            -100847472093088506 + μ * (
                8929489333108377 + μ * (
                    -426353946885548 + μ * (
                        13172003634537 + μ * (
                            -291245357370 + μ * (
                                4148944183
                            )
                        )
                    )
                )
            )
        )
    ) / 13059009124761600
    b = 0.25 * (2ν + 4k - 1) * π
    # Evaluate using Horner's scheme:
    x = b - (μ - 1) * (((((((a13 / b^2 + a11) / b^2 + a9) / b^2 + a7) / b^2 + a5) / b^2 + a3) / b^2 + a1) / b)
    return x
end

function _piessens_chebyshev30(ν::Float64)
    # Piessens's Chebyshev series approximations (1984). Calculates the 6 first
    # zeros to at least 12 decimal figures in region -1 ≤ ν ≤ 5:
    pt = (ν - 2) / 3

    T1 = 1.0
    T2 = pt
    T3 = 2pt * T2 - T1
    T4 = 2pt * T3 - T2
    T5 = 2pt * T4 - T3
    T6 = 2pt * T5 - T4
    T7 = 2pt * T6 - T5
    T8 = 2pt * T7 - T6
    T9 = 2pt * T8 - T7
    T10 = 2pt * T9 - T8
    T11 = 2pt * T10 - T9
    T12 = 2pt * T11 - T10
    T13 = 2pt * T12 - T11
    T14 = 2pt * T13 - T12
    T15 = 2pt * T14 - T13
    T16 = 2pt * T15 - T14
    T17 = 2pt * T16 - T15
    T18 = 2pt * T17 - T16
    T19 = 2pt * T18 - T17
    T20 = 2pt * T19 - T18
    T21 = 2pt * T20 - T19
    T22 = 2pt * T21 - T20
    T23 = 2pt * T22 - T21
    T24 = 2pt * T23 - T22
    T25 = 2pt * T24 - T23
    T26 = 2pt * T25 - T24
    T27 = 2pt * T26 - T25
    T28 = 2pt * T27 - T26
    T29 = 2pt * T28 - T27
    T30 = 2pt * T29 - T28

    T = SVector(T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26, T27, T28, T29, T30)
    return T
end

function piessens(ν::Float64)
    # Piessens's Chebyshev series approximations (1984). Calculates the 6 first
    # zeros to at least 12 decimal figures in region -1 ≤ ν ≤ 5:
    C = PIESSENS_C
    T = _piessens_chebyshev30(ν)
    y = C' * T
    return Base.setindex(y, y[1] * sqrt(ν + 1), 1)
end


function besselZeroRoots(m)
    # BESSEL0ROOTS ROOTS OF BESSELJ(0,x). USE ASYMPTOTICS.
    # Use McMahon's expansion for the remainder (NIST, 10.21.19):
    jk = Array{Float64}(undef, m)
    p = (
        1071187749376 / 315, 0.0, -401743168 / 105, 0.0, 120928 / 15,
        0.0, -124 / 3, 0.0, 1.0, 0.0,
    )
    # First 20 are precomputed:
    @inbounds for jj in 1:min(m, 20)
        jk[jj] = BESSELJ0_ROOTS[jj]
    end
    @inbounds for jj in 21:min(m, 47)
        ak = π * (jj - 0.25)
        ak82 = (0.125 / ak)^2
        jk[jj] = ak + 0.125 / ak * evalpoly(ak82, (1.0, p[7], p[5], p[3]))
    end
    @inbounds for jj in 48:min(m, 344)
        ak = π * (jj - 0.25)
        ak82 = (0.125 / ak)^2
        jk[jj] = ak + 0.125 / ak * evalpoly(ak82, (1.0, p[7], p[5]))
    end
    @inbounds for jj in 345:min(m, 13191)
        ak = π * (jj - 0.25)
        ak82 = (0.125 / ak)^2
        jk[jj] = ak + 0.125 / ak * muladd(ak82, p[7], 1.0)
    end
    @inbounds for jj in 13192:m
        ak = π * (jj - 0.25)
        jk[jj] = ak + 0.125 / ak
    end
    return jk
end

function besselJ1(m)
    # BESSELJ1 EVALUATE BESSELJ(1,x)^2 AT ROOTS OF BESSELJ(0,x).
    # USE ASYMPTOTICS. Use Taylor series of (NIST, 10.17.3) and McMahon's
    # expansion (NIST, 10.21.19):
    Jk2 = Array{Float64}(undef, m)
    c = (
        -171497088497 / 15206400, 461797 / 1152, -172913 / 8064,
        151 / 80, -7 / 24, 0.0, 2.0,
    )
    # First 10 are precomputed:
    @inbounds for jj in 1:min(m, 10)
        Jk2[jj] = BESSELJ1_ON_BESSELJ0_ROOTS[jj]
    end
    @inbounds for jj in 11:min(m, 15)
        ak = π * (jj - 0.25)
        ak2 = (1 / ak)^2
        Jk2[jj] = 1 / (π * ak) * muladd(evalpoly(ak2, (c[5], c[4], c[3], c[2], c[1])), ak2^2, c[7])
    end
    @inbounds for jj in 16:min(m, 21)
        ak = π * (jj - 0.25)
        ak2 = (1 / ak)^2
        Jk2[jj] = 1 / (π * ak) * muladd(evalpoly(ak2, (c[5], c[4], c[3], c[2])), ak2^2, c[7])
    end
    @inbounds for jj in 22:min(m, 55)
        ak = π * (jj - 0.25)
        ak2 = (1 / ak)^2
        Jk2[jj] = 1 / (π * ak) * muladd(evalpoly(ak2, (c[5], c[4], c[3])), ak2^2, c[7])
    end
    @inbounds for jj in 56:min(m, 279)
        ak = π * (jj - 0.25)
        ak2 = (1 / ak)^2
        Jk2[jj] = 1 / (π * ak) * muladd(muladd(ak2, c[4], c[5]), ak2^2, c[7])
    end
    @inbounds for jj in 280:min(m, 2279)
        ak = π * (jj - 0.25)
        ak2 = (1 / ak)^2
        Jk2[jj] = 1 / (π * ak) * muladd(ak2^2, c[5], c[7])
    end
    @inbounds for jj in 2280:m
        ak = π * (jj - 0.25)
        Jk2[jj] = 1 / (π * ak) * c[7]
    end
    return Jk2
end

Base.@deprecate besselroots(ν::Real, n::Integer) approx_besselroots(ν, n)

@testset "Gauss–Radau" begin
    @testset "Check error" begin
        @test_throws DomainError gaussradau(0)
        @test_throws DomainError gaussradau(0,0,0)
    end

    @testset "Legendre" begin
        n = 1
        x, w = gaussradau(n)
        @test x[1] ≈ -1.
        @test w[1] ≈ 2.

        n = 2
        x, w = gaussradau(n)
        @test x[1] ≈ -1.
        @test x[2] ≈ 1/3
        @test w[1] ≈ .5
        @test w[2] ≈ 1.5

        tol = 1e-14
        n = 42
        ntests = 4
        x, w = gaussradau(n)
        @test length(x) == n && length(w) == n
        @test abs(x[37] - 0.908847278001044) < tol
        @test abs(w[37] - 0.031190846817016) < tol
        @test x[1] == -1

        @test dot( w,exp.(x)) ≈ exp(1)-exp(-1)
    end
    @testset "Jacobi" begin
        for (a,b) in ((0.1, 0.2), (0,-0.5))
            # compare with Gauss–Jacobi
            for n = 1:5
                x, w = gaussradau(n, a, b)
                x̃, w̃ = gaussjacobi(n, a, b)

                @test length(x) == n

                @test sum(w) ≈ sum(w̃)
                for j = 1:2n-2
                    @test dot(w,x.^j) ≈ dot(w̃,x̃.^j)
                end
            end
        end

        # compare with Gauss-Radau-Legendre
        @test all(gaussradau(2, 0, 0) .≈ gaussradau(2))
        @test all(gaussradau(3, 0, 0) .≈ gaussradau(3))
    end
end

using FastGaussQuadrature
using Test, Aqua, LinearAlgebra, Random, SpecialFunctions

Aqua.test_all(FastGaussQuadrature)

@testset "FastGaussQuadrature.jl" begin
    include("test_gausschebyshev.jl")
    include("test_gausslegendre.jl")
    include("test_gaussjacobi.jl")
    include("test_gaussradau.jl")
    include("test_gausslobatto.jl")
    include("test_besselroots.jl")
    include("test_gausslaguerre.jl")
    include("test_gausshermite.jl")
end

@doc raw"""
    gausslegendre([T=Float64,] n::Integer) -> x, w  # nodes, weights

Return nodes `x` and weights `w` of [Gauss-Legendre quadrature](https://en.wikipedia.org/wiki/Gauss%E2%80%93Legendre_quadrature) with type `T`.

```math
\int_{-1}^{1} f(x) dx \approx \sum_{i=1}^{n} w_i f(x_i)
```

# Examples
```jldoctest
julia> x, w = gausslegendre(3);

julia> f(x) = x^4;

julia> I = dot(w, f.(x));

julia> I ≈ 2/5
true
```
"""
@inline function gausslegendre(::Type{T}, n::Integer) where {T}
    # GAUSSLEGENDRE(n) COMPUTE THE GAUSS-LEGENDRE NODES AND WEIGHTS IN O(n) time.

    if n < 0
        throw(DomainError(n, "Input n must be a non-negative integer"))
    elseif n == 0
        return T[], T[]
    elseif n == 1
        return T[0], T[2]
    elseif n == 2
        sqrt3 = sqrt(T(3))
        return [T(-1) / sqrt3, 1 / sqrt3], T[1, 1]
    elseif n == 3
        sqrt3_5 = sqrt(T(3) / 5)
        return [-sqrt3_5, T(0), sqrt3_5], [5, 8, 5] ./ T(9)
    elseif n == 4
        a = 2 * sqrt(T(6) / 5) / 7
        T3_7 = T(3) / 7
        sqrt30 = sqrt(T(30))
        return (
            [-sqrt(T3_7 + a), -sqrt(T3_7 - a), sqrt(T3_7 - a), sqrt(T3_7 + a)],
            [
                (18 - sqrt30) / 36, (18 + sqrt30) / 36,
                (18 + sqrt30) / 36, (18 - sqrt30) / 36,
            ],
        )
    elseif n == 5
        b = 2 * sqrt(T(10) / 7)
        sqrt70 = sqrt(T(70))
        return (
            [
                -sqrt(5 + b) / 3, -sqrt(5 - b) / 3, T(0),
                sqrt(5 - b) / 3, sqrt(5 + b) / 3,
            ],
            [
                (322 - 13 * sqrt70) / 900, (322 + 13 * sqrt70) / 900, T(128) / 225,
                (322 + 13 * sqrt70) / 900, (322 - 13 * sqrt70) / 900,
            ],
        )
    elseif n ≤ 60 || T != Float64
        # NEWTON'S METHOD WITH THREE-TERM RECURRENCE:
        return rec(T, n)
    else
        # USE ASYMPTOTIC EXPANSIONS:
        return asy(n)
    end
end
gausslegendre(n::Integer) = gausslegendre(Float64, n)

function asy(n)
    # COMPUTE GAUSS-LEGENDRE NODES AND WEIGHTS USING ASYMPTOTIC EXPANSIONS.
    # COMPLEXITY O(n).

    # Nodes and weights:
    m = (n + 1) >> 1
    a = besselZeroRoots(m)
    rmul!(a, 1 / (n + 0.5))
    x = legpts_nodes(n, a)
    w = legpts_weights(n, m, a)
    # Use symmetry to get the others:
    resize!(x, n)
    resize!(w, n)
    @inbounds for i in 1:m
        x[n + 1 - i] = x[i]
        w[n + 1 - i] = w[i]
    end
    @inbounds for i in 1:m
        x[i] = -x[i]
    end
    @inbounds isodd(n) && (x[m] = 0.0)

    return x, w
end

function legpts_nodes(n, a)
    # ASYMPTOTIC EXPANSION FOR THE GAUSS-LEGENDRE NODES.
    vn = 1 / (n + 0.5)
    m = length(a)
    nodes = cot.(a)
    vn² = vn * vn
    vn⁴ = vn² * vn²
    @inbounds if n ≤ 255
        vn⁶ = vn⁴ * vn²
        for i in 1:m
            u = nodes[i]
            u² = u^2
            ai = a[i]
            ai² = ai * ai
            ai³ = ai² * ai
            ai⁵ = ai² * ai³
            node = ai + (u - 1 / ai) / 8 * vn²
            v1 = (6 * (1 + u²) / ai + 25 / ai³ - u * muladd(31, u², 33)) / 384
            v2 = u * evalpoly(u², (2595 / 15360, 6350 / 15360, 3779 / 15360))
            v3 = (1 + u²) * (
                -muladd(31 / 1024, u², 11 / 1024) / ai +
                    u / 512 / ai² + -25 / 3072 / ai³
            )
            v4 = (v2 - 1073 / 5120 / ai⁵ + v3)
            node = muladd(v1, vn⁴, node)
            node = muladd(v4, vn⁶, node)
            nodes[i] = node
        end
    elseif n ≤ 3950
        for i in 1:m
            u = nodes[i]
            u² = u^2
            ai = a[i]
            ai² = ai * ai
            ai³ = ai² * ai
            node = ai + (u - 1 / ai) / 8 * vn²
            v1 = (6 * (1 + u²) / ai + 25 / ai³ - u * muladd(31, u², 33)) / 384
            node = muladd(v1, vn⁴, node)
            nodes[i] = node
        end
    else
        for i in 1:m
            u = nodes[i]
            ai = a[i]
            node = ai + (u - 1 / ai) / 8 * vn²
            nodes[i] = node
        end
    end
    @inbounds for jj in 1:m
        nodes[jj] = cos(nodes[jj])
    end

    return nodes
end

function legpts_weights(n, m, a)
    # ASYMPTOTIC EXPANSION FOR THE GAUSS-LEGENDRE WEIGHTS.
    vn = 1 / (n + 0.5)
    vn² = vn^2
    weights = Array{Float64}(undef, m)
    if n ≤ 850000
        @inbounds for i in 1:m
            weights[i] = cot(a[i])
        end
    end
    # Split out the part that can be vectorized by llvm
    @inbounds if n ≤ 170
        for i in 1:m
            u = weights[i]
            u² = u^2
            ai = a[i]
            ai⁻¹ = 1 / ai
            ai² = ai^2
            ai⁻² = 1 / ai²
            ua = u * ai
            W1 = muladd(ua - 1, ai⁻², 1.0) / 8
            W2 = evalpoly(
                ai⁻², (
                    evalpoly(u², (-27.0, -84.0, -56.0)),
                    muladd(-3.0, muladd(u², -2.0, 1.0), 6 * ua),
                    muladd(ua, -31.0, 81.0),
                )
            ) / 384
            W3 = evalpoly(
                ai⁻¹, (
                    evalpoly(u², (153 / 1024, 295 / 256, 187 / 96, 151 / 160)),
                    evalpoly(u², (-65 / 1024, -119 / 768, -35 / 384)) * u,
                    evalpoly(u², (5 / 512, 15 / 512, 7 / 384)),
                    muladd(u², 1 / 512, -13 / 1536) * u,
                    muladd(u², -7 / 384, + 53 / 3072),
                    3749 / 15360 * u, -1125 / 1024,
                )
            )
            weights[i] = evalpoly(vn², (1 / vn² + W1, W2, W3))
        end
    elseif n ≤ 1500
        for i in 1:m
            u = weights[i]
            u² = u^2
            ai = a[i]
            ai² = ai^2
            ai⁻² = 1 / ai²
            ua = u * ai
            W1 = muladd(ua - 1, ai⁻², 1.0) / 8
            W2 = evalpoly(
                ai⁻², (
                    evalpoly(u², (-27.0, -84.0, -56.0)),
                    muladd(-3.0, muladd(u², -2.0, 1.0), 6 * ua),
                    muladd(ua, -31.0, 81.0),
                )
            ) / 384
            weights[i] = muladd(vn², W2, 1 / vn² + W1)
        end
    elseif n ≤ 850000
        for i in 1:m
            u = weights[i]
            u² = u^2
            ai = a[i]
            ai² = ai^2
            ai⁻² = 1 / ai²
            ua = u * ai
            W1 = muladd(ua - 1, ai⁻², 1.0) / 8
            weights[i] = 1 / vn² + W1
        end
    else
        for i in 1:m
            weights[i] = 1 / vn²
        end
    end
    bJ1 = besselJ1(m)
    @inbounds for i in 1:m
        weights[i] = 2 / (bJ1[i] * (a[i] / sin(a[i])) * weights[i])
    end

    return weights
end

function rec(::Type{T}, n) where {T}
    # COMPUTE GAUSS-LEGENDRE NODES AND WEIGHTS USING NEWTON'S METHOD.
    # THREE-TERM RECURENCE IS USED FOR EVALUATION. COMPLEXITY O(n^2).

    # Initial guess:
    x = T.(leg_initial_guess(n))

    # Perform Newton to find zeros of Legendre polynomial:
    PP1, PP2 = similar(x), similar(x)

    # Two iterations of Newton's method
    num_iters = if T == Float64
        2
    else
        ceil(Int, (log(max(20, precision(T)) / 50) + 1) * 2)
    end
    for _ in 1:num_iters
        innerRec!(PP1, PP2, n, x)
        newt_step!(x, PP1, PP2)
    end

    # Use symmetry to get the other Legendre nodes and weights:
    m = length(x)
    resize!(x, n)
    resize!(PP2, n)
    @inbounds for i in 1:(m - 1)
        x[n + 1 - i] = -x[i]
        PP2[n + 1 - i] = -PP2[i]
    end
    @inbounds for i in 1:n
        PP2[i] = T(2) / ((1 - x[i]^2) * PP2[i]^2)
    end

    return x, PP2
end

@inline function innerRec!(myPm1, myPPm1, n, x)
    # EVALUATE LEGENDRE AND ITS DERIVATIVE USING THREE-TERM RECURRENCE RELATION.
    N = length(x)
    T = eltype(x)
    @inbounds for j in 1:N
        xj = x[j]
        Pm2 = T(1)
        Pm1 = xj
        PPm1 = T(1)
        PPm2 = T(0)
        for k in 1:(n - 1)
            Pm2, Pm1 = Pm1, muladd((2 * k + 1) * Pm1, xj, - k * Pm2) / (k + 1)
            PPm2, PPm1 = PPm1, (
                    (2 * k + 1) * muladd(xj, PPm1, Pm2) -
                    k * PPm2
                ) / (k + 1)
        end
        myPm1[j] = Pm1
        myPPm1[j] = PPm1
    end
    return myPm1, myPPm1
end

@inline function newt_step!(x, PP1, PP2)
    # In-place iteration of Newton's method.
    return @inbounds @simd for i in eachindex(x)
        x[i] -= PP1[i] / PP2[i]
    end
end

@inline function leg_initial_guess(n)
    # Returns an approximation of the first n÷2+1 roots of the Legendre polynomial.
    #  The following is equivalent to "x0 = asy(n)[1]; x = x0[1:n ÷ 2 + 1]" but it avoids unnecessary calculations.

    m = (n ÷ 2) + 1
    a = besselZeroRoots(m)
    rmul!(a, 1 / (n + 0.5))
    x = legpts_nodes(n, a)
    rmul!(x, -1.0)
    return x
end

@testset "Bessel Roots" begin
    @test_throws DomainError approx_besselroots(0.0, -1)

    @test_deprecated besselroots(0.2,3)

    # Check if besselj(ν, approx_besselroots(ν, n) ) is small:
    tol = 1e-11

    for ν = 0.:0.1:5.
        n = 10
        @test norm( besselj.(ν, approx_besselroots(ν, n) ), Inf ) < tol
    end
end

@testset "Gauss–Chebyshev" begin

    @testset "Check error" begin
        @test_throws DomainError gausschebyshevt(-1)
        @test_throws DomainError gausschebyshevu(-1)
        @test_throws DomainError gausschebyshevv(-1)
        @test_throws DomainError gausschebyshevw(-1)
    end

    n = 10

    @testset "x.^2" begin
        x, w = gausschebyshevt(n)
        @test dot(x.^2,w) ≈ π/2
        x, w = gausschebyshevu(n)
        @test dot(x.^2,w) ≈ π/8
        x, w = gausschebyshevv(n)
        @test dot(x.^2,w) ≈ π/2
        x, w = gausschebyshevw(n)
        @test dot(x.^2,w) ≈ π/2
    end

    @testset "x^3" begin
        x, w = gausschebyshevt(n)
        @test abs(dot(x.^3,w)) < 1e-15
        x, w = gausschebyshevu(n)
        @test abs(dot(x.^3,w)) < 1e-15
        x, w = gausschebyshevv(n)
        @test dot(x.^3,w) ≈ 3*π/8
        x, w = gausschebyshevw(n)
        @test dot(x.^3,w) ≈ -3*π/8
    end

    @testset "deprecated" begin
        n = 42
        @test gausschebyshevt(n) == @test_deprecated gausschebyshev(n, 1)
        @test gausschebyshevu(n) == @test_deprecated gausschebyshev(n, 2)
        @test gausschebyshevv(n) == @test_deprecated gausschebyshev(n, 3)
        @test gausschebyshevw(n) == @test_deprecated gausschebyshev(n, 4)
        @test_throws ArgumentError gausschebyshev(0,5)
    end
end

using FastGaussQuadrature, LinearAlgebra, Luxor
logocolors = Luxor.Colors.JULIA_LOGO_COLORS

@svg begin
    n = 15
    Drawing(500,500, "docs/src/assets/logo.svg")
    origin()
    unitlength = 210
    translate(0, unitlength)

    Y = (n+1/2)/π

    x_lgd, w_lgd = gausslegendre(n)
    x_cbs, w_cbs = gausschebyshev(n,3)
    x_jcb, w_jcb = gaussjacobi(n,5/2,1/2)

    c_lgd = logocolors[1]  # Red
    c_cbs = logocolors[2]  # Green
    c_jcb = logocolors[4]  # Purple

    p_jcb = [Point(unitlength*x_jcb[i], -Y*unitlength*w_jcb[i]) for i in 1:n]
    p_cbs = [Point(unitlength*x_cbs[i], -Y*unitlength*w_cbs[i]) for i in 1:n]
    p_lgd = [Point(unitlength*x_lgd[i], -Y*unitlength*w_lgd[i]) for i in 1:n]

    l_jcb = [norm(p_jcb[i+1]-p_jcb[i]) for i in 1:n-1]
    l_cbs = [norm(p_cbs[i+1]-p_cbs[i]) for i in 1:n-1]
    l_lgd = [norm(p_lgd[i+1]-p_lgd[i]) for i in 1:n-1]

    r_jcb = zeros(n)
    r_cbs = zeros(n)
    r_lgd = zeros(n)

    r_jcb[end] = norm(l_jcb[end])/2 * 0.8
    r_cbs[end] = norm(l_cbs[end])/2 * 0.7
    r_lgd[end] = norm(l_lgd[end])/2 * 0.75

    for i in reverse(1:n-1) r_jcb[i] = l_jcb[i] - r_jcb[i+1] end
    for i in reverse(1:n-1) r_cbs[i] = l_cbs[i] - r_cbs[i+1] end
    for i in reverse(1:n-1) r_lgd[i] = l_lgd[i] - r_lgd[i+1] end

    sethue(c_cbs)
    for i in 5:n circle(p_cbs[i], r_cbs[i], :fill) end
    sethue(c_jcb)
    for i in 1:n circle(p_jcb[i], r_jcb[i], :fill) end
    sethue(c_lgd)
    for i in 1:n circle(p_lgd[i], r_lgd[i], :fill) end
    sethue(c_cbs)
    for i in 1:4 circle(p_cbs[i], r_cbs[i], :fill) end

    finish()
    preview()
end

run(`convert -density 256x256 -background transparent docs/src/assets/logo.svg -define icon:auto-resize -colors 256 docs/src/assets/favicon.ico`)

using LinearAlgebra, GenericLinearAlgebra

@testset "Gauss–Legendre" begin
    @testset "quad: $quad" for quad in (gausslegendre, gaussradau)
        @testset "n: $n" for n in (2, 3, 4, 5, 6, 7, 8, 9, 40, 100)
            # check BigFloat
            x, w = @inferred quad(n)
            xbig, wbig = @inferred quad(BigFloat, n)
            @test length(xbig) == n && length(wbig) == n
            @test ≈(x, xbig; atol = 1.0e-14)
            @test ≈(w, wbig; atol = 1.0e-14)
            # tests bigfloat coefs by integrating against random polynomial
            poly_coefs = rand(BigFloat, 2n - 1)
            poly_coefs = FastGaussQuadrature.jacobi_gw(2n - 1, big(0.0), big(0.0))[1]
            test_fun(x) = evalpoly(x, poly_coefs)
            # analytic integral of f
            integral_testfun(x) = x * evalpoly(x, [p / i for (i, p) in enumerate(poly_coefs)])
            @test ≈(dot(wbig, test_fun.(xbig)), integral_testfun(1) - integral_testfun(-1); atol = 1.0e-70)
        end
    end
end

@testset "Gauss–Hermite" begin
    # n values cover: special cases (1), GW (≤20), rec (21–200), asy→rec for BigFloat (>200)
    @testset "n: $n" for n in (1, 2, 10, 21, 100, 250)
        x, w = @inferred gausshermite(n)
        xbig, wbig = @inferred gausshermite(BigFloat, n)
        @test length(xbig) == n && length(wbig) == n
        @test ≈(x, xbig; atol = n ≤ 200 ? 1.0e-14 : 1.0e-13)
        @test ≈(w, wbig; atol = n ≤ 200 ? 1.0e-14 : 1.0e-12)
        # ∫ x^2 exp(-x^2) dx = sqrt(π)/2, exact for n ≥ 2
        n ≥ 2 && @test ≈(dot(wbig, xbig .^ 2), sqrt(big(π)) / 2; atol = n == 21 ? 1.0e-50 : 1.0e-70)
    end
end

@testset "Gauss–Laguerre" begin
    # n values cover: special cases (1,2), GW (<15), rec (15–127), asy→rec for BigFloat (≥128)
    @testset "n: $n" for n in (1, 2, 3, 10, 20, 130)
        x, w = @inferred gausslaguerre(n)
        xbig, wbig = @inferred gausslaguerre(BigFloat, n)
        @test length(xbig) == n && length(wbig) == n
        @test ≈(x, xbig; atol = n < 128 ? 1.0e-13 : 1.0e-12)
        @test ≈(w, wbig; atol = 1.0e-13)
        # ∫ x exp(-x) dx = 1, exact for n ≥ 2
        n ≥ 2 && @test ≈(dot(wbig, xbig), big(1); atol = 1.0e-70)
    end

    # non-zero α: type inferred from α, or set explicitly via T
    @testset "α ≠ 0, n: $n" for n in (3, 10, 20, 130)
        α = 0.5
        x, w = @inferred gausslaguerre(n, α)
        xbig, wbig = @inferred gausslaguerre(n, big(α))
        @test ≈(x, xbig; atol = 1.0e-12)
        @test ≈(w, wbig; atol = 1.0e-14)
        # ∫ x * x^α exp(-x) dx = Γ(α+2), exact for n ≥ 1
        @test ≈(dot(wbig, xbig), gamma(big(α) + 2); atol = 1.0e-70)
    end
end

@testset "Gauss–Lobatto" begin
    @testset "n: $n" for n in (3, 4, 5, 6, 7, 8, 9, 40, 100)
        # check BigFloat
        x, w = @inferred gausslobatto(n)
        xbig, wbig = @inferred gausslobatto(BigFloat, n)
        @test length(xbig) == n && length(wbig) == n
        @test ≈(x, xbig; atol = 1.0e-14)
        @test ≈(w, wbig; atol = 1.0e-14)
        # tests bigfloat coefs by integrating against a polynomial of degree 2n-3
        # (exact for Lobatto with n points, which integrates degree 2n-3 exactly)
        poly_coefs = FastGaussQuadrature.jacobi_gw(2n - 3, big(0.0), big(0.0))[1]
        test_fun(x) = evalpoly(x, poly_coefs)
        integral_testfun(x) = x * evalpoly(x, [p / i for (i, p) in enumerate(poly_coefs)])
        @test ≈(dot(wbig, test_fun.(xbig)), integral_testfun(1) - integral_testfun(-1); atol = 1.0e-70)
    end
end

@testset "Gauss–Legendre" begin

    # Check error
    @test_throws DomainError gausslegendre(-1)

    # Check all special cases
    @test gausslegendre(0) == (Float64[], Float64[])
    for ν in 0:10
        (x, w) = gausslegendre(ν)
        for i in 0:(ν - 1)
            r = 2i
            @test abs(dot(w, (x .^ r)) - 2 / (r + 1)) < 10 * eps()
        end
    end

    tol = 1.0e-14
    n = 42
    x, w = @inferred gausslegendre(n)
    @test length(x) == n && length(w) == n
    @test ≈(x[37], 0.910959724904127; atol = tol)
    @test ≈(w[37], 0.030479240699603; atol = tol)

    @test dot(w, (x .^ 2)) ≈ 2 / 3
    @test dot(w, exp.(x)) ≈ exp(1) - exp(-1)

    # Test a larger n (using ASY)
    n = 251
    x, w = gausslegendre(n)
    @test all(length(x) == n) && all(length(w) == n)
    @test abs(x[37] + 0.896467746955729) < tol
    @test abs(w[37] - 0.005535005742012) < tol

    @test dot(w, (x .^ 2)) ≈ 2 / 3
    @test dot(w, exp.(x)) ≈ exp(1) - exp(-1)

    x, w = gausslegendre(1013)
    @test norm(x[2] - -0.99998516758611, Inf) < tol
    @test norm(x[13] - -0.999218995240887, Inf) < tol
    @test norm(w[2] - 1.681691163200592e-5, Inf) < tol
    @test norm(w[13] - 1.224755309137936e-4, Inf) < tol

    @test dot(w, (x .^ 2)) ≈ 2 / 3
    @test dot(w, exp.(x)) ≈ exp(1) - exp(-1)

    x, w = gausslegendre(10013)
    @test norm(x[2] - -0.999999848054223, Inf) < tol
    @test norm(x[13] - -0.999991998242661, Inf) < tol
    @test norm(w[2] - 1.722757320118474e-7, Inf) < tol
    @test norm(w[13] - 1.25498054003247e-6, Inf) < tol

    @test dot(w, (x .^ 2)) ≈ 2 / 3
    @test dot(w, exp.(x)) ≈ exp(1) - exp(-1)
end

using Documenter
using FastGaussQuadrature

# Setup for doctests in docstrings
DocMeta.setdocmeta!(FastGaussQuadrature, :DocTestSetup, :(using LinearAlgebra, SpecialFunctions, FastGaussQuadrature))

makedocs(;
    modules = [FastGaussQuadrature],
    format = Documenter.HTML(
        canonical = "https://JuliaApproximation.github.io/FastGaussQuadrature.jl/stable/",
        assets = ["assets/favicon.ico"],
        repolink = "https://github.com/JuliaApproximation/FastGaussQuadrature.jl"
    ),
    pages = [
        "Home" => "index.md",
        "Gaussian Quadrature" => "gaussquadrature.md",
        "Benchmark" => "benchmark.md",
        "Roots of Bessel function" => "besselroots.md",
        "Misc." => "misc.md",
        "References" => "reference.md",
    ],
    repo = "https://github.com/JuliaApproximation/FastGaussQuadrature.jl/blob/{commit}{path}#L{line}",
    sitename = "FastGaussQuadrature.jl",
    authors = "Alex Townsend, Sheehan Olver, Peter Opsomer, and contributors.",
)

deploydocs(; repo = "github.com/JuliaApproximation/FastGaussQuadrature.jl")

# References

[1] I. Bogaert, ["Iteration-free computation of Gauss-Legendre quadrature nodes and weights"](http://epubs.siam.org/doi/abs/10.1137/140954969), SIAM J. Sci. Comput., 36(3), A1008-A1026, 2014.

[2] A. Glaser, X. Liu, and V. Rokhlin. ["A fast algorithm for the calculation of the roots of special functions."](http://epubs.siam.org/doi/pdf/10.1137/06067016X) SIAM J. Sci. Comput., 29 (2007), 1420-1438.

[3] N. Hale and A. Townsend, ["Fast and accurate computation of Gauss-Legendre and Gauss-Jacobi quadrature nodes and weights"](http://epubs.siam.org/doi/abs/10.1137/120889873), SIAM J. Sci. Comput., 2012.

[4] J. C. Mason and D. C. Handscomb, ["Chebyshev Polynomials"](https://books.google.co.jp/books?id=8FHf0P3to0UC), CRC Press, 2002.

[5] P. Opsomer, (in preparation).

[6] A. Townsend, [The race for high order Gauss-Legendre quadrature](http://pi.math.cornell.edu/~ajt/papers/QuadratureEssay.pdf), in SIAM News, March 2015.

[7] A. Townsend, T. Trogdon, and S. Olver, ["Fast computation of Gauss quadrature nodes and weights on the whole real line"](http://arxiv.org/abs/1410.5286), to appear in IMA Numer. Anal., 2014.

[8] M. Vanlessen, "Strong asymptotics of Laguerre-Type orthogonal polynomials and applications in Random Matrix Theory", Constr. Approx., 25:125-175, 2007.

# Gaussian Quadrature


## Gauss-Legendre quadrature
Gauss quadrature for the weight function ``w(x) = 1``.

* For ``n ≤ 5``: Use an analytic expression.
* For ``n ≤ 60``: Use Newton's method to solve ``P_n(x)=0``. Evaluate Legendre polynomials ``P_n`` and their derivatives ``P_n'`` by 3-term recurrence. Weights are related to ``P_n'``.
* For ``n > 60``: Use asymptotic expansions for the Legendre nodes and weights [[1]](http://epubs.siam.org/doi/abs/10.1137/140954969).

```@docs
gausslegendre(n::Integer)
```


## Gauss-Hermite quadrature
Gauss quadrature for the weight function ``w(x) = \exp(-x^2)`` on the real line.

* For ``n < 200``: Use Newton's method to solve ``H_n(x)=0``. Evaluate Hermite polynomials ``H_n`` and their derivatives ``H_n'`` by three-term recurrence.
* For ``n ≥ 200``: Use Newton's method to solve ``H_n(x)=0``. Evaluate ``H_n`` and ``H_n'`` by a uniform asymptotic expansion, see [[7]](http://arxiv.org/abs/1410.5286).

The paper [[7]](http://arxiv.org/abs/1410.5286) also derives an ``O(n)`` algorithm for generalized Gauss-Hermite nodes and weights associated to weight functions of the form ``\exp(-V(x))``, where ``V(x)`` is a real polynomial.

```@docs
gausshermite(n::Integer)
```


## Gauss-Laguerre quadrature
Gauss quadrature for the weight function ``w(x) = \exp(-x)`` on ``[0,+\infty)``

* For ``n < 128``: Use the Golub-Welsch algorithm.
* For `method=GLR`: Use the Glaser-Lui-Rohklin algorithm. Evaluate Laguerre polynomials ``L_n`` and their derivatives ``L_n'`` by using Taylor series expansions near roots generated by solving the second-order differential equation that ``L_n`` satisfies, see [[2]](http://epubs.siam.org/doi/pdf/10.1137/06067016X).
* For ``n ≥ 128``: Use a Newton procedure on Riemann-Hilbert asymptotics of Laguerre polynomials, see [5], based on [8]. There are some heuristics to decide which expression to use, it allows a general weight ``w(x) = x^\alpha \exp(-q_m x^m)`` and this is ``O(\sqrt{n})`` when allowed to stop when the weights are below the smallest positive floating point number.

```@docs
gausslaguerre(n::Integer)
```

```@docs
gausslaguerre(n::Integer, α::Real)
```


## Gauss-Chebyshev quadrature
There are four kinds of Gauss-Chebyshev quadrature rules, corresponding to four weight functions:

* 1st kind, weight function ``w(x) = 1/\sqrt{1-x^2}``
* 2nd kind, weight function ``w(x) = \sqrt{1-x^2}``
* 3rd kind, weight function ``w(x) = \sqrt{(1+x)/(1-x)}``
* 4th kind, weight function ``w(x) = \sqrt{(1-x)/(1+x)}``

They are all have explicit simple formulas for the nodes and weights [[4]](https://books.google.co.jp/books?id=8FHf0P3to0UC).

```@docs
gausschebyshevt(n::Integer)
gausschebyshevu(n::Integer)
gausschebyshevv(n::Integer)
gausschebyshevw(n::Integer)
```


## Gauss-Jacobi quadrature
Gauss quadrature for the weight functions ``w(x) = (1-x)^\alpha(1+x)^\beta``, ``\alpha,\beta > -1``.

* For ``n ≤ 100``: Use Newton's method to solve ``P_n(x)=0``. Evaluate ``P_n`` and ``P_n'`` by three-term recurrence.
* For ``n > 100``: Use Newton's method to solve ``P_n(x)=0``. Evaluate ``P_n`` and ``P_n'`` by an asymptotic expansion (in the interior of ``[-1,1]``) and the three-term recurrence ``O(n^{-2})`` close to the endpoints. (This is a small modification to the algorithm described in [[3]](http://epubs.siam.org/doi/abs/10.1137/120889873).)
* For ``\max(\alpha,\beta) > 5``: Use the Golub-Welsch algorithm requiring ``O(n^2)`` operations.

```@docs
gaussjacobi(n::Integer, α::Real, β::Real)
```


## Gauss-Radau quadrature
Gauss quadrature for the weight function ``w(x)=1``, except the endpoint ``-1`` is included as a quadrature node.

The Gauss-Radau nodes and weights can be computed via the ``(0,1)`` Gauss-Jacobi nodes and weights[[3]](http://epubs.siam.org/doi/abs/10.1137/120889873).

```@docs
gaussradau(n::Integer)
```


## Gauss-Lobatto quadrature
Gauss quadrature for the weight function ``w(x)=1``, except the endpoints ``-1`` and ``1`` are included as nodes.

The Gauss-Lobatto nodes and weights can be computed via the ``(1,1)`` Gauss-Jacobi nodes and weights[[3]](http://epubs.siam.org/doi/abs/10.1137/120889873).

```@docs
gausslobatto(n::Integer)
```

# Roots of Bessel function

Since [SpecialFunctions.jl](https://github.com/JuliaMath/SpecialFunctions.jl) doesn't have a method to calculate roots of [Bessel function](https://en.wikipedia.org/wiki/Bessel_function), we implemented `approx_besselroots`.

```@docs
approx_besselroots(ν::Real, n::Integer)
```

This method `approx_besselroots` is used to calculate `gaussjacobi` and `gausslaguerre`.

# Misc.

## About the logo
![](assets/logo.svg)

* The center points of circles are generated from nodes(x-axis) and weights(y-axis) of Gaussian quadrature.
    * Number of points : `n = 15`
    * ``\textcolor{#CB3C33}{\text{\textbf{Red}}}`` : `gausslegendre(n)`
    * ``\textcolor{#389826}{\text{\textbf{Green}}}`` : `gausschebyshev(n, 3)`
    * ``\textcolor{#9558B2}{\text{\textbf{Purple}}}`` : `gaussjacobi(n, 5/2, 1/2)`
* These colors are from [julia-logo-graphics](https://github.com/JuliaLang/julia-logo-graphics).
* The logo is generated with [Luxor.jl](https://github.com/JuliaGraphics/Luxor.jl), and its source code is [here](https://github.com/JuliaApproximation/FastGaussQuadrature.jl/blob/master/docs/logo.jl).


## Other docstrings from private methods

```@autodocs
Modules = [FastGaussQuadrature]
Private = true
Public = false
```

# Benchmark

Here we compute `100000` nodes and weights of the Gauss rules.
Try a million or ten million.

```@repl
using LinearAlgebra, BenchmarkTools, FastGaussQuadrature
@btime gausschebyshev(100000);
@btime gausslegendre(100000);
@btime gaussjacobi(100000, 0.9, -0.1);
@btime gaussradau(100000);
@btime gausslobatto(100000);
@btime gausslaguerre(100000);
@btime gausshermite(100000);
```

The paper [[1]](http://epubs.siam.org/doi/abs/10.1137/140954969) computed a billion Gauss-Legendre nodes.
So here we will do a billion + 1.

```julia
julia> @btime gausslegendre(1000000001);
  23.363 s (10 allocations: 22.35 GiB)
```

(The nodes near the endpoints coalesce in 16-digits of precision.)

# FastGaussQuadrature.jl

## Abstract

FastGaussQuadrature.jl is a Julia package to compute `n`-point Gauss quadrature nodes and weights to 16-digit accuracy and in `O(n)` time.
So far the package includes `gausschebyshev()`, `gausslegendre()`, `gaussjacobi()`, `gaussradau()`, `gausslobatto()`, `gausslaguerre()`, and `gausshermite()`.
This package is heavily influenced by [Chebfun](http://www.chebfun.org).

An introduction to Gauss quadrature can be found [here](http://en.wikipedia.org/wiki/Gaussian_quadrature).
For a quirky account on the history of computing Gauss-Legendre quadrature, see [[6]](http://pi.math.cornell.edu/~ajt/papers/QuadratureEssay.pdf).

## Our Aims

* The fastest Julia code for Gauss quadrature nodes and weights (without tabulation).
* Change the perception that Gauss quadrature rules are expensive to compute.

## First example
To check an integral
```math
\int_{-1}^{1} x^4 dx = \frac{2}{5}
```
by numerically, try following code.

```@repl
using FastGaussQuadrature, LinearAlgebra
x, w = gausslegendre(3)
f(x) = x^4
I = dot(w, f.(x))
I ≈ 2/5
```
